/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.client;

import org.bytedeco.javacpp.opencv_core;

/**
 *
 * @author apple
 */
public class FeatureExtraction extends Thread implements Runnable {
        
    private String host;
    private int port;
    private java.util.ArrayList<opencv_core.Mat> faceList;
    private java.io.File parent;
    private boolean expression;
    private FeatureExtractionListener listener;
    private FeatureExtractor extractor;
    
    
    public interface FeatureExtractionListener{
        public void failed(String status);
        public void success(java.util.List<opencv_core.Mat> featureListMat, java.util.List<float[]> featureListFloat, java.util.List<String[]> expressionList);
    }
    
    public FeatureExtraction( String host, int port, java.util.ArrayList<opencv_core.Mat> faceList, java.io.File parent, boolean expression ){
        this.host = host;
        this.port = port;
        this.faceList = faceList;
        this.parent = parent;
        this.expression = expression;
        
        extractor = new FeatureExtractor( this.host, this.port );
    }
    
    
    public void setLinstener( FeatureExtractionListener listener ){
        this.listener = listener;
    }
    
    @Override
    public void run(){
        extractor.extract(faceList, parent, expression);
        listener.success( extractor.getFeatureListMat(), extractor.getFeatureListFloat(), extractor.getExpressionList());
    }
}
