/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.client;

import java.awt.image.BufferedImage;
import org.bytedeco.javacpp.opencv_core;

/**
 *
 * @author apple
 */
public class MultipleRecognition extends Thread implements Runnable {
        
    private String host;
    private int port;
    private java.util.ArrayList<opencv_core.Mat> faceList;
    private java.io.File parent;
    private boolean expression;
    private MultipleRecognitionListener listener;
    private MultipleRecognizer extractor;
    
    
    public interface MultipleRecognitionListener{
        public void failed(String status);
        public void success( java.util.List<String[]> resultList, java.util.List<BufferedImage> photoList, java.util.List<String[]> expressionList);
    }
    /**
     * 
     * @param host domain name or server IP address
     * @param port server port number
     * @param faceList list of faces to recognize
     * @param parent temporarily folder to store face images
     * @param expression true to extract facial expression otherwise false
     */
    public MultipleRecognition( String host, int port, java.util.ArrayList<opencv_core.Mat> faceList, java.io.File parent, boolean expression ){
        this.host = host;
        this.port = port;
        this.faceList = faceList;
        this.parent = parent;
        this.expression = expression;
        
        extractor = new MultipleRecognizer( this.host, this.port );
    }
    
    
    public void setLinstener( MultipleRecognitionListener listener ){
        this.listener = listener;
    }
    
    @Override
    public void run(){
        extractor.extract(faceList, parent, expression);
        listener.success( extractor.getResultList(), extractor.getPhotoList(), extractor.getExpressionList());
    }
}
