/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.client;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.Socket;
import org.bytedeco.javacpp.opencv_core;
import static org.bytedeco.javacpp.opencv_imgcodecs.imwrite;

/**
 *
 * @author apple
 */
public class Registration extends Thread implements Runnable{
            
    private Socket clientSocket;
    private String name;
    private int id=0;
    private int linkId=0;
    private opencv_core.Mat face;
    private String host;
    private int port;
    private RegistrationListener listener;
    
    
    public interface RegistrationListener{
        public void failed( String status );
        public void success( String id );
    }
       
    public Registration(opencv_core.Mat face, String name, int id, int linkId, String host, int port){
        this.face = face;
        this.name = name;
        this.id = id;
        this.linkId = linkId;
        this.host = host;
        this.port = port;
    }
    
    public Registration(opencv_core.Mat face, String name, int id, String host, int port){
        this.face = face;
        this.name = name;
        this.id = id;
        this.host = host;
        this.port = port;
    }
        
    public Registration(opencv_core.Mat face, String name, String host, int port ){
        this.face = face;
        this.name = name;
        this.host = host;
        this.port = port;
    }
    
    
        @Override
        public void run() {
                    
            try{
                clientSocket = new Socket( host, port );
                clientSocket.setReuseAddress( true );
                DataInputStream dis = new DataInputStream(new BufferedInputStream( clientSocket.getInputStream()));
                DataOutputStream dos = new DataOutputStream(new BufferedOutputStream( clientSocket.getOutputStream()));

                dos.writeUTF("register");
                dos.flush();
                
                dos.writeUTF( this.id +"-"+ this.name +"-"+ this.linkId);
                dos.flush();
         
                try{
                    java.io.File f1 = new java.io.File( "rtmp.jpg" );
                    f1.createNewFile();
                    imwrite( f1.getAbsolutePath(), this.face.clone() );
                    
                    dos.writeLong( f1.length() );
                    dos.flush();
                    
                    byte[] buffer = new byte[4096];
                    InputStream ios = new FileInputStream( f1 );
                    int totalByte = 0;
                    int read = 0;
                    while ((read = ios.read(buffer)) != -1) {
                        dos.write(buffer, 0, read);
                        dos.flush( );
                        totalByte += read;
                    }
                    ios.close();
                    
                    System.out.println(f1.length() +"," + totalByte);
                    f1.delete();
                }catch(Exception ex){ex.printStackTrace();}
                
                String response = dis.readUTF( );
                System.out.println( "Response:" + response );
                dos.close();
                dis.close();
                
                if( response.equalsIgnoreCase("failed"))
                    listener.failed(response);
                else
                    listener.success( response );
                
                
            }catch(Exception ex){
                listener.failed( ex.getLocalizedMessage() );
                ex.printStackTrace(); 
            }
            
        }
     
        public void setListener( RegistrationListener listener ){
            this.listener = listener;
        }
}
