/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.detection;


import com.ml.vision.autoface.camera.CameraAdvanced;
import com.ml.vision.autoface.listener.DetectionListener;
import org.bytedeco.javacpp.opencv_core;

/**
 *
 * @author apple
 */
public class DetectionManager extends Thread implements Runnable{
    private java.util.List<Object[]> queue = new java.util.ArrayList<>();
    private boolean stopIt = false;
    private FaceDetection detection;
    public DetectionListener listener;
    private boolean rectangleFace = true;
    private boolean sortFaceBySize = true;
    
    public DetectionManager( FaceDetection detection ){
        this.detection = detection;
    }
    
    @Override
    public void run( ){
        try{
            while( true){
                if(isStopIt()){ break; }
                sleep( 0,1 );
                
                if(  !queue.isEmpty() ){
                    Object[] o = queue.remove( 0 );
                    try{
                        CameraAdvanced camera = (CameraAdvanced)o[0];
                        java.util.List<opencv_core.Mat> cap = detection.detectFace( camera.getLastCapture(), true, isRectangleFace(), camera.getAlgorithm(), true );
                        listener.onDetectedFaces( cap, camera, (long) o[1] );
                    }catch(Exception ex){}
                }
            }
        }catch(Exception ex){ex.printStackTrace();}
    }

    public void setListener( DetectionListener listener ){
        this.listener = listener;
    }
    public void detect( Object[] o ){
        queue.add(o);
    }
    
    public boolean isStopIt() {
        return stopIt;
    }

    public void setStopIt(boolean stopIt) {
        this.stopIt = stopIt;
    }

    public boolean isRectangleFace() {
        return rectangleFace;
    }

    public void setRectangleFace(boolean rectangleFace) {
        this.rectangleFace = rectangleFace;
    }

    public boolean isSortFaceBySize() {
        return sortFaceBySize;
    }

    public void setSortFaceBySize(boolean sortFaceBySize) {
        this.sortFaceBySize = sortFaceBySize;
    }
    
    
}
