/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.detection;


import java.awt.image.BufferedImage;
import org.bytedeco.javacpp.DoublePointer;
import org.bytedeco.javacpp.opencv_core;
import static org.bytedeco.javacpp.opencv_core.NORM_MINMAX;
import org.bytedeco.javacpp.opencv_core.Point;
import static org.bytedeco.javacpp.opencv_core.minMaxLoc;
import static org.bytedeco.javacpp.opencv_core.normalize;
import org.bytedeco.javacpp.opencv_dnn;
import static org.bytedeco.javacpp.opencv_dnn.blobFromImage;
import static org.bytedeco.javacpp.opencv_dnn.readNetFromCaffe;
import org.bytedeco.javacpp.opencv_imgcodecs;
import static org.bytedeco.javacpp.opencv_imgcodecs.imread;
import static org.bytedeco.javacpp.opencv_imgproc.resize;
import org.bytedeco.javacv.Java2DFrameConverter;
import org.bytedeco.javacv.OpenCVFrameConverter;

/**
 *
 * @author apple
 */
public class EmotionDetection {
    //https://github.com/IMS94/javacv-cnn-example
    
    private opencv_dnn.Net net = null;
    
    private static final String[] categories = new String[]{ "Angry", "Disgust", "Fear", "Happy", "Neutral", "Sad", "Surprise","Unknown" };
    public static final String PROTO_FILE = "model/deploy_emotion.prototxt"; //model/deploy_agenet.prototxt
    public static final String CAFFE_MODEL_FILE = "model/EmotiW_VGG_S.caffemodel"; // age_net.caffemodel
    
    public static void main(String args[]){
        EmotionDetection ageDetector = new EmotionDetection();
        opencv_core.Mat testImage = imread("trained/346-moethantoo.jpg", opencv_imgcodecs.IMREAD_ANYCOLOR);
        String gender = ageDetector.caffemodel( testImage );
        System.out.println("Age="+gender);
    }
    public EmotionDetection() {
        try{
            net = readNetFromCaffe(PROTO_FILE, CAFFE_MODEL_FILE);
        }catch(Exception ex){}
    }
    
           
    public String caffemodel( BufferedImage image ){
        return caffemodel( new OpenCVFrameConverter.ToIplImage().convertToMat( new Java2DFrameConverter( ).convert( image )) );
    }
    
    public int caffemodel( opencv_core.Mat image, int noAction ){
        try{
            resize(image, image, new opencv_core.Size(256,256));//resize the image to match the input size of the model
            normalize(image, image, 0, Math.pow(2, 8), NORM_MINMAX, -1, null);
            //create a 4-dimensional blob from image with NCHW (Number of images in the batch -for training only-, Channel, Height, Width) dimensions order,
            //for more detailes read the official docs at https://docs.opencv.org/trunk/d6/d0f/group__dnn.html#gabd0e76da3c6ad15c08b01ef21ad55dd8
            opencv_core.Mat blob = blobFromImage( image);

            net.setInput(blob, "data", 1.0, null);//set the input to network model
            opencv_core.Mat output = net.forward("prob" );//feed forward the input to the netwrok to get the output matrix


            DoublePointer pointer = new DoublePointer(new double[1]);
            Point max = new Point();
            minMaxLoc( output, null, pointer, null, max, null);
            return max.x();
        }catch(Exception ex){ex.printStackTrace();}
        
        return 7;
    }
    public String caffemodel( opencv_core.Mat image ){
        return categories[caffemodel(image, 0)];
    }
}
