/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.detection.objects;


import com.ml.vision.autoface.camera.CameraAdvanced;
import java.util.List;
import java.util.Map;

/**
 *
 * @author apple
 */
public class ObjectDetectionManager extends Thread implements Runnable{
    private java.util.List<Object[]> queue = new java.util.ArrayList<>();
    private boolean stopIt = false;
    public ObjectDetectionManagerListener listener;
    private boolean rectangleFace = true;
    private boolean sortFaceBySize = true;
    
    public interface ObjectDetectionManagerListener{
        public void onDemographic(List<String[]> demographic, Map<String, Integer> increasedCount, CameraAdvanced camera, long timeMilis);
    }

    @Override
    public void run( ){
        try{
            while( true){
                if(isStopIt()){ break; }
                sleep( 0,1 );
                
                if(  !queue.isEmpty() ){
                    Object[] o = queue.remove( 0 );
                    try{
                        CameraAdvanced camera = (CameraAdvanced)o[0];
                        Yolov3 objectDetector = camera.getObjectDetector();
                        objectDetector.detect( camera.getLastCapture() );
                        listener.onDemographic( objectDetector.getDemographic(), objectDetector.getIncreasedCount(), camera, (long) o[1]);
                    }catch(Exception ex){}
                }
            }
        }catch(Exception ex){ex.printStackTrace();}
    }

    public void setListener( ObjectDetectionManagerListener listener ){
        this.listener = listener;
    }
    public void detect( Object[] o ){
        queue.add(o);
    }
    
    public boolean isStopIt() {
        return stopIt;
    }

    public void setStopIt(boolean stopIt) {
        this.stopIt = stopIt;
    }

    public boolean isRectangleFace() {
        return rectangleFace;
    }

    public void setRectangleFace(boolean rectangleFace) {
        this.rectangleFace = rectangleFace;
    }

    public boolean isSortFaceBySize() {
        return sortFaceBySize;
    }

    public void setSortFaceBySize(boolean sortFaceBySize) {
        this.sortFaceBySize = sortFaceBySize;
    }
    
    
}
