/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.recognition;


import org.bytedeco.javacpp.opencv_core;
import static org.bytedeco.javacpp.opencv_core.CV_32F;
import org.bytedeco.javacpp.opencv_dnn;
import static org.bytedeco.javacpp.opencv_dnn.blobFromImage;
import static org.bytedeco.javacpp.opencv_dnn.readNetFromTorch;
import static org.bytedeco.javacpp.opencv_imgproc.resize;

/**
 *
 * @author apple
 */
public class NetLoader128 extends NetLoader {
    public static final int NET_VECTOR_SIZE = 128;
    private opencv_dnn.Net net = null;
    
    public NetLoader128(){
        net  = readNetFromTorch("model/nn4.small2.v1.t7");
    }
        
    @Override
    public opencv_core.Mat processFace( opencv_core.Mat img ) {
        resize( img, img, new opencv_core.Size(224, 224));
        opencv_core.Mat blob =  //blobFromImage(img, 1./255, new Size(96,96), Scalar.all(0), true, false);
        blobFromImage( img, 1./255, new opencv_core.Size(96, 96), new opencv_core.Scalar(0, 0, 0, 0), false, false, CV_32F );
        net.setInput( blob );
        return net.forward().clone( );
    }
    public opencv_dnn.Net getNet(){return net;}
    @Override
    public int getNetSize(){return NET_VECTOR_SIZE;}
}
