/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.recognition;


import org.bytedeco.javacpp.opencv_core;
import static org.bytedeco.javacpp.opencv_core.CV_32F;
import org.bytedeco.javacpp.opencv_dnn;
import static org.bytedeco.javacpp.opencv_dnn.blobFromImage;
import static org.bytedeco.javacpp.opencv_dnn.readNetFromCaffe;
import static org.bytedeco.javacpp.opencv_imgproc.resize;
/**
 *
 * @author apple
 */
public class NetLoader2622 extends NetLoader{
    
    public static final int NET_VECTOR_SIZE = 2622;
    private opencv_dnn.Net net = null;
    public static final String PROTO_FILE = "model/VGG_FACE_deploy.prototxt";
    public static final String CAFFE_MODEL_FILE = "model/VGG_FACE.caffemodel";
    
    public NetLoader2622(){
        net  = readNetFromCaffe( PROTO_FILE, CAFFE_MODEL_FILE );
    }
     
    @Override
    public opencv_core.Mat processFace( opencv_core.Mat img ) {
        resize( img, img, new opencv_core.Size(224, 224));
        opencv_core.Mat blob = blobFromImage(img, 1.0, new opencv_core.Size(224, 224), 
                new opencv_core.Scalar(129.1863, 104.7624, 93.5940, 0), false, false, CV_32F );
        net.setInput( blob );
        return net.forward( "fc8" ).clone( ); // 
    }
    @Override
    public int getNetSize(){return NET_VECTOR_SIZE;}
}
