/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.recognition;

import com.ml.vision.autoface.camera.CameraAdvanced;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import org.bytedeco.javacpp.opencv_core;

/**
 *
 * @author apple
 */
public class RecognitionManager extends Thread implements Runnable {
    
    private java.util.List<Object[]> queue = new java.util.ArrayList<>();
    private boolean stopIt = false;
    private RecognitionManagerLinster listener;
    private Recognition dbRecognition;
    
    public interface RecognitionManagerLinster{
        /**
         * 
         * @param camera 
         * @param resultData _id, name, registered Date, linkId, distance
         * @param profileImage 
         */
        public void onRecognize( CameraAdvanced camera,String resultData [], BufferedImage profileImage);
    }
    
    @Override
    public void run(){
        try {
            dbRecognition = new Recognition( );
        } catch (Exception ex) { Logger.getLogger(RecognitionManager.class.getName()).log(Level.SEVERE, null, ex); }
                
        try{
            while( true ){
                if(isStopIt()){ break; }
                sleep( 0, 1 );
                
//                System.out.println("Queue size="+ queue.size());
                
                if(  !queue.isEmpty() && dbRecognition!=null && listener != null ){
                    Object[] o = queue.remove( 0 );
                    try{
                        opencv_core.Mat face = (opencv_core.Mat) o[0];
                        Object dataObj[] = dbRecognition.predission( face, 0, 0 );
                        String resultData [] = (String[]) dataObj[0];
                        BufferedImage profileImage = null;
                        
                        if( dataObj[1] != null ){
                            byte profile[] = (byte[]) dataObj[1];
                            profileImage = ImageIO.read( new ByteArrayInputStream( profile) );
                        }
                        listener.onRecognize( (CameraAdvanced) o[1], resultData, profileImage );
                        face.release();
                        face.close();
                    }catch(Exception ex){ex.printStackTrace();}
                }
            }
        }catch(Exception ex){}
    }    
    
    public int save( String name, opencv_core.Mat imgbgr, String profilePath, String photoPath, int linkId ){
        return save( 0, name, imgbgr, profilePath, photoPath, linkId );
    }
    
    public int save( int id, String name, opencv_core.Mat imgbgr, String profilePath, String photoPath, int linkId ){
        return dbRecognition.save(id, name, imgbgr, profilePath, photoPath, linkId);
    }
    
    public void recognize( Object[] o ){
        queue.add( o );
    }
    
    public boolean isStopIt() {
        return stopIt;
    }

    public void setStopIt(boolean stopIt) {
        this.stopIt = stopIt;
    }
    
    public void setListener( RecognitionManagerLinster listener ){
        this.listener = listener;
    }
}
