/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.recognition.remote;

import kong.unirest.HttpResponse;
import kong.unirest.JsonNode;
import kong.unirest.Unirest;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

/**
 *
 * @author apple
 */
public class LuxandRecognition {
    // This is your API token
    private static final String TOKEN = "b2e8d68dda6244afb02982922275f7d8";
    
    // This method is going to be used to send all the requests
    private HttpResponse<JsonNode> post_request(String url, Map<String, Object> fields) {
        return Unirest.post(url)
                .header("token", TOKEN)
                .fields(fields)
                .asJson();
    }
    
    public int register( String name, java.io.File photo ){
        int id = 0;
        
        try{
            HttpResponse<JsonNode> response = post_request("https://api.luxand.cloud/subject",
                    new HashMap<String, Object>() {{ put("name", name); }});

            if (response.getStatus() != 200){
                System.out.printf(response.getBody( ).getObject( ).getString( "message" ) );
                System.exit( 1 );
            }
            
            id = response.getBody( ).getObject( ).getInt( "id" );
            System.out.println( "Created person for "+ name +", ID=" + id );
            
            // You can also upload file from local storage instead of using URL
            // post_request(String.format("https://api.luxand.cloud/subject/%d", response.getBody().getObject().getInt("id")),
            //         new HashMap<String, Object>() {{ put("photo", new File("/path/to/file") ); }});
            response = post_request(String.format("https://api.luxand.cloud/subject/%d", id ),
                    new HashMap<String, Object>() {{ put("photo", photo); }});
            
            
            System.out.println( response.getBody().toString( ) );
        }catch(Exception ex){ex.printStackTrace();}
        
        return id;
    }
    
    public String recognize( java.io.File photo ){
        String data = null;
        try{
            // You can also upload file from local storage instead of using URL
        // post_request("https://api.luxand.cloud/photo/search", new HashMap<String, Object>() {{ put("photo", new File("/path/to/file") ); }});
            HttpResponse<JsonNode> response = post_request("https://api.luxand.cloud/photo/search",
                new HashMap<String, Object>() {{ put("photo", photo ); }});
            
            data = response.getBody().toString();
            System.out.println( data );
            
        }catch(Exception ex){ 
            ex.printStackTrace(); 
        }
        
        return data;
    }
    
    public boolean isLive( java.io.File photo ){
        boolean result = false;
        
        try{
            // You can also upload file from local storage instead of using URL
            // post_request("https://api.luxand.cloud/photo/liveness", new HashMap<String, Object>() {{ put("photo", new File("/path/to/file") ); }});
            HttpResponse<JsonNode> response = post_request("https://api.luxand.cloud/photo/liveness",
                    new HashMap<String, Object>() {{ put("photo", photo ); }});

            if (response.getStatus() != 200){
                System.out.printf(response.getBody().getObject().getString("message"));
                System.exit(1);
            }

            kong.unirest.JsonNode node = response.getBody();
            
            if( node.getObject().getString("status").equalsIgnoreCase("success")){
                if( ((kong.unirest.json.JSONObject) node.getObject( ).getJSONArray("result").get(0)).getString("result").equalsIgnoreCase("real"))
                    result = true;    
            }
            System.out.println( node.toString() );
            System.out.println( result );
            
        }catch(Exception ex){ex.printStackTrace();}
        
        return result;
    }
    
    public static void main( String args[] ){
        LuxandRecognition rg = new LuxandRecognition( );
        //rg.register("Nwe Ni Soe", new java.io.File("/Users/apple/Desktop/tmp/p/nwe-ni-soe.jpg"));
        
        //rg.isLive( new java.io.File("/Users/apple/Desktop/tmp/mto-from-db.jpg") );
        String resultData = rg.recognize( new java.io.File("/Users/apple/Desktop/tmp/p/myo-hlaing-win-face.jpg") );
        
    }
}
