/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.ui.ad.age;

import com.ml.vision.autoface.camera.CameraAdvanced;
import com.ml.vision.autoface.detection.AgeDetection;
import com.ml.vision.autoface.detection.EmotionDetection;
import com.ml.vision.autoface.detection.FaceDetection;
import com.ml.vision.autoface.detection.GenderDetection;
import com.ml.vision.autoface.listener.CameraListener;
import com.ml.vision.autoface.util.ImageFilter;
import com.ml.vision.autoface.util.ScaleFit;
import java.awt.image.BufferedImage;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import org.bytedeco.javacpp.opencv_core;

/**
 *
 * @author apple
 */
public class AgeGenderEmotion extends javax.swing.JFrame {

    private java.util.List<String> lstgender = new java.util.ArrayList<>(2);
    private java.util.List<String> lstage = new java.util.ArrayList<>(9);
    private java.util.List<String> lstemotion = new java.util.ArrayList<>(8);
    private static String[] GENDERS = new String[]{"Male", "Female"};
    private static final String[] AGES = new String[]{"0-2", "4-6", "8-13", "15-20", "25-32", "38-43", "48-53", "60+","Unknown"};
    private static final String[] EMOTIONS = new String[]{ "Angry", "Disgust", "Fear", "Happy", "Neutral", "Sad", "Surprise","Unknown" };
    private GenderDetection genderDetector;
    private AgeDetection ageDetector;
    private EmotionDetection emotionDetector;
    private FaceDetection detection;
    private CameraAdvanced cam;
    
    /**
     * Creates new form AgeGenderEmotion
     */
    public AgeGenderEmotion() {
        initComponents();
        jFileChooser1.addChoosableFileFilter(new ImageFilter());
        
        for( int i=0; i < cbogender.getItemCount(); i++ )
            lstgender.add("mm-beer/advertising-design.jpg");
        
        for( int i=0; i < cboage.getItemCount()+1; i++ ){
            lstage.add("mm-beer/advertising-design.jpg");
            lstemotion.add("mm-beer/advertising-design.jpg");
        }
        
        new Thread(new Runnable() {
            @Override
            public void run( ) {
                detection = new FaceDetection( );
                genderDetector = new GenderDetection();
                ageDetector = new AgeDetection();
                emotionDetector = new EmotionDetection();
                registerCamera( );
            }
        }).start( );
    }

       
    private void registerCamera( ){
         String url = "rtsp://admin:abcd1234@192.168.1.64:554/Streaming/Channels/101"; //"/Users/apple/Desktop/masha/CM-Bharat-Ane-Nenu-2018-HDRip-720p.mp4"; 
        cam = new CameraAdvanced( 0 );
        cam.setAlgorithm( FaceDetection.ALGORITHM_CASCADE_CLASSIFIER );
        cam.setFramePerSecond(1);
        cam.setListener(new CameraListener( ) {
            @Override
            public void onCaptureByFPS(CameraAdvanced camera) { }

            @Override
            public void onCapture(CameraAdvanced camera) {
                
                opencv_core.Mat frame = camera.getLastCapture( );
                java.util.List<opencv_core.Mat> cap = detection.detectFace( frame, true, false, cam.getAlgorithm(), true );
                java.util.List<opencv_core.Rect> lstRect = detection.getLstRect();
                cap.forEach((face) ->{
                    
                    int age = ageDetector.caffemodel(face, 0 );
                    int gender = genderDetector.caffemodel(face, 0);
                    int emo = emotionDetector.caffemodel(face, 0);
                    lblinfo.setText( AGES[age] + "," + GENDERS[gender] + "," + EMOTIONS[emo] );
                    //dos.writeUTF(age+","+gender+","+emo);
                    System.out.println( age + "," + gender + "," + emo );
                    
                    try {
                        BufferedImage sourceFile = ImageIO.read( new java.io.File( lstemotion.get(emo) ) );
                        lbldisplay.setIcon( new ImageIcon( ScaleFit.scaleFit(sourceFile, 600) ));
                    } catch (Exception ex) {
                        Logger.getLogger( AgeGenderEmotion.class.getName()).log(Level.SEVERE, null, ex);
                    }
                });
                /*
                lstRect.forEach((rect) -> {
                    //F = (P x  D) / W
                    float F = ( PN * DN ) / W;
                    float D = ( ( F * W ) / rect.width( ) ) / 12;
                    //System.out.println("w=" + rect.width()+",h=" + rect.height()+". Distance=" + D+"in");
                    lbldistance.setText("Distance:" + String.format("%.2f", D) + " ft");
                    display( D );
                });
                */
            }

            @Override
            public void onCapture( List<opencv_core.Mat> faces, CameraAdvanced camera ) {
            }

            @Override
            public void onFailed(CameraAdvanced camera) {}

             @Override
             public void onDemographic(List<String[]> demographic, Map<String, Integer> increasedCount, CameraAdvanced camera) {
                 throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
             }
        });
        cam.start();
    }
    
    
    private void selectFile( int index ){
        try{
            jFileChooser1.showOpenDialog(this);
            java.io.File selectedFile = jFileChooser1.getSelectedFile();

            if( selectedFile != null ){
                if( index == 1){
                    lblpath1.setText(selectedFile.getAbsolutePath());
                    lstgender.set( cbogender.getSelectedIndex(), selectedFile.getAbsolutePath() );
                }else if( index == 2){
                    lblpath2.setText(selectedFile.getAbsolutePath());
                    lstage.set( cboage.getSelectedIndex(), selectedFile.getAbsolutePath() );
                }else if( index == 3){
                        lblpath3.setText(selectedFile.getAbsolutePath());
                    lstemotion.set( cboemotion.getSelectedIndex(), selectedFile.getAbsolutePath() );
                }
            }
        }catch(Exception ex){}
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFileChooser1 = new javax.swing.JFileChooser();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        lbldisplay = new javax.swing.JLabel();
        lblinfo = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        btnbrowse3 = new javax.swing.JButton();
        lblpath3 = new javax.swing.JLabel();
        btnok3 = new javax.swing.JButton();
        cboemotion = new javax.swing.JComboBox<>();
        jPanel5 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        btnbrowse1 = new javax.swing.JButton();
        lblpath1 = new javax.swing.JLabel();
        btnok1 = new javax.swing.JButton();
        cbogender = new javax.swing.JComboBox<>();
        jPanel6 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        btnbrowse2 = new javax.swing.JButton();
        lblpath2 = new javax.swing.JLabel();
        btnok2 = new javax.swing.JButton();
        cboage = new javax.swing.JComboBox<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        lbldisplay.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbldisplay.setIcon(new javax.swing.ImageIcon(getClass().getResource("/camera.png"))); // NOI18N
        lbldisplay.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        lbldisplay.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        lblinfo.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        lblinfo.setForeground(java.awt.Color.red);
        lblinfo.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblinfo.setText("What?");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lbldisplay, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(lblinfo, javax.swing.GroupLayout.DEFAULT_SIZE, 668, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(lbldisplay, javax.swing.GroupLayout.DEFAULT_SIZE, 413, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblinfo))
        );

        jTabbedPane1.addTab("Display", jPanel1);

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Emotion"));

        jLabel1.setText("Gender:");

        jLabel4.setText("Display(Image,Video):");

        btnbrowse3.setText("Browse");
        btnbrowse3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnbrowse3ActionPerformed(evt);
            }
        });

        lblpath3.setText("Path:");

        btnok3.setText("OK");
        btnok3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnok3ActionPerformed(evt);
            }
        });

        cboemotion.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Angry", "Disgust", "Fear", "Happy", "Neutral", "Sad", "Surprise" }));
        cboemotion.setSelectedIndex(3);

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(btnbrowse3)
                            .addComponent(cboemotion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(lblpath3, javax.swing.GroupLayout.PREFERRED_SIZE, 548, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnok3)))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(cboemotion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(btnbrowse3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblpath3)
                    .addComponent(btnok3))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Gender"));

        jLabel2.setText("Gender:");

        jLabel5.setText("Display(Image,Video):");

        btnbrowse1.setText("Browse");
        btnbrowse1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnbrowse1ActionPerformed(evt);
            }
        });

        lblpath1.setText("Path:");

        btnok1.setText("OK");
        btnok1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnok1ActionPerformed(evt);
            }
        });

        cbogender.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Male", "Female" }));

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(btnbrowse1)
                            .addComponent(cbogender, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(lblpath1, javax.swing.GroupLayout.PREFERRED_SIZE, 551, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnok1)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(cbogender, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(btnbrowse1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblpath1)
                    .addComponent(btnok1))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("Age"));

        jLabel3.setText("Gender:");

        jLabel6.setText("Display(Image,Video):");

        btnbrowse2.setText("Browse");
        btnbrowse2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnbrowse2ActionPerformed(evt);
            }
        });

        lblpath2.setText("Path:");

        btnok2.setText("OK");
        btnok2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnok2ActionPerformed(evt);
            }
        });

        cboage.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0-2", "4-6", "8-13", "15-20", "25-32", "38-43", "48-53", "60+" }));
        cboage.setSelectedIndex(4);

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(btnbrowse2)
                            .addComponent(cboage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanel6Layout.createSequentialGroup()
                        .addComponent(lblpath2, javax.swing.GroupLayout.PREFERRED_SIZE, 539, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnok2)))
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(cboage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(btnbrowse2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblpath2)
                    .addComponent(btnok2))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Settings", jPanel2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnbrowse3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnbrowse3ActionPerformed
        // TODO add your handling code here:
        selectFile( 3 );
    }//GEN-LAST:event_btnbrowse3ActionPerformed

    private void btnok3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnok3ActionPerformed
        /*
        try {
            // TODO add your handling code here:

            BufferedImage sourceFile = ImageIO.read( new java.io.File(lblpath3.getText()) );
            lbldisplay.setIcon( new ImageIcon( ScaleFit.scaleFit(sourceFile, 600) ));
        } catch (IOException ex) {
            Logger.getLogger(HumanDistance.class.getName()).log(Level.SEVERE, null, ex);
        }
        setValue( );
        */
    }//GEN-LAST:event_btnok3ActionPerformed

    private void btnbrowse1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnbrowse1ActionPerformed
        // TODO add your handling code here:
        selectFile( 1 );
    }//GEN-LAST:event_btnbrowse1ActionPerformed

    private void btnok1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnok1ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_btnok1ActionPerformed

    private void btnbrowse2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnbrowse2ActionPerformed
        // TODO add your handling code here:
        selectFile( 2 );
    }//GEN-LAST:event_btnbrowse2ActionPerformed

    private void btnok2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnok2ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_btnok2ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(AgeGenderEmotion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(AgeGenderEmotion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(AgeGenderEmotion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(AgeGenderEmotion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new AgeGenderEmotion().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnbrowse1;
    private javax.swing.JButton btnbrowse2;
    private javax.swing.JButton btnbrowse3;
    private javax.swing.JButton btnok1;
    private javax.swing.JButton btnok2;
    private javax.swing.JButton btnok3;
    private javax.swing.JComboBox<String> cboage;
    private javax.swing.JComboBox<String> cboemotion;
    private javax.swing.JComboBox<String> cbogender;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel lbldisplay;
    private javax.swing.JLabel lblinfo;
    private javax.swing.JLabel lblpath1;
    private javax.swing.JLabel lblpath2;
    private javax.swing.JLabel lblpath3;
    // End of variables declaration//GEN-END:variables
}
