/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.ui.ad.distance;

import com.ml.vision.autoface.camera.CameraAdvanced;
import com.ml.vision.autoface.detection.FaceDetection;
import com.ml.vision.autoface.listener.CameraListener;
import com.ml.vision.autoface.ui.ad.util.VideoPlayer;
import com.ml.vision.autoface.util.ImageFilter;
import com.ml.vision.autoface.util.ScaleFit;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import org.bytedeco.javacpp.opencv_core;
import org.bytedeco.javacv.Java2DFrameConverter;
import org.bytedeco.javacv.OpenCVFrameConverter;
import javafx.embed.swing.JFXPanel;
/**
 *
 * @author apple
 */
public class HumanDistance extends javax.swing.JFrame {
    
    public static final int DN = 20;
    public static final int PN= 250;//260~240
    public static final int W = 6;//6~4
    
    
    private FaceDetection detection;
    private CameraAdvanced cam;
    private float a1Start=0;
    private float a1End = 0;
    private float a2Start=0;
    private float a2End = 0;
    private float a3Start=0;
    private float a3End = 0;
    private VideoPlayer videoPlayer;
    private int currentIndex = 0;    
    private String status="";
    
    
    /**
     * Creates new form HumanDistance
     */
    public HumanDistance( ) {
        initComponents();        
        
        jFileChooser1.addChoosableFileFilter(new ImageFilter());
        new Thread(new Runnable() {
            @Override
            public void run( ) {
                registerCamera( );
                detection = new FaceDetection( );
                setValue();
                //videoDisplay( "mm-beer/y2mate.com - oh_my_god_jLO1CPYv0hc_360p.mp4" );
            }
        }).start( );
    }
        
    private void registerCamera( ){
         String url = "rtsp://admin:abcd1234@192.168.1.64:554/Streaming/Channels/101"; //"/Users/apple/Desktop/masha/CM-Bharat-Ane-Nenu-2018-HDRip-720p.mp4"; 
        cam = new CameraAdvanced( 0 );
        cam.setAlgorithm( FaceDetection.ALGORITHM_CASCADE_CLASSIFIER );
        cam.setListener(new CameraListener( ) {
            @Override
            public void onCaptureByFPS(CameraAdvanced camera) { }

            @Override
            public void onCapture(CameraAdvanced camera) {
                
                opencv_core.Mat frame = camera.getLastCapture( );
                java.util.List<opencv_core.Mat> cap = detection.detectFace( frame, true, false, cam.getAlgorithm(), true );
                java.util.List<opencv_core.Rect> lstRect = detection.getLstRect();
                
                lstRect.forEach((rect) -> {
                    //F = (P x  D) / W
                    float F = ( PN * DN ) / W;
                    float D = ( ( F * W ) / rect.width( ) ) / 12;
                    System.out.println("w=" + rect.width()+",h=" + rect.height()+". Distance=" + D+"in");
                    lbldistance.setText("Distance:" + String.format("%.2f", D) + " ft");
                    display( D );
                });
            }

            @Override
            public void onCapture( List<opencv_core.Mat> faces, CameraAdvanced camera ) {
            }

            @Override
            public void onFailed(CameraAdvanced camera) {}

             @Override
             public void onDemographic(List<String[]> demographic, Map<String, Integer> increasedCount, CameraAdvanced camera) {
                 throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
             }
        });
        cam.start();
    }
    
    private void selectFile( int index ){
        try{
            jFileChooser1.showOpenDialog(this);
            java.io.File selectedFile = jFileChooser1.getSelectedFile();

            if( selectedFile != null ){
                if( index == 1)
                    lblpath1.setText(selectedFile.getAbsolutePath());
                else if( index == 2)
                    lblpath2.setText(selectedFile.getAbsolutePath());
                else if( index == 3)
                    lblpath3.setText(selectedFile.getAbsolutePath());
            }
        }catch(Exception ex){}
    }
    
    private void display( float distance ){

        if( status.equals(VideoPlayer.STATUS_LOADING) || status.equals(VideoPlayer.STATUS_READY) || status.equals(VideoPlayer.STATUS_PLAYING))
            return;
        
        try{
            if( distance >= a1Start && distance <= a1End && !lblpath1.getText().isEmpty() && currentIndex != 1){
                currentIndex = 1;
                if( lblpath1.getText().endsWith(".mp4"))
                    videoDisplay( lblpath1.getText() );
                else
                    imageDisplay( lblpath1.getText() );
                
            }else if( distance >= a2Start && distance <= a2End && !lblpath2.getText().isEmpty() && currentIndex != 2 ){
                currentIndex = 2;
                if( lblpath2.getText().endsWith(".mp4"))
                    videoDisplay( lblpath2.getText() );
                else
                    imageDisplay( lblpath2.getText() );
                
            }else if( distance >= a3Start && distance <= a3End  && !lblpath3.getText().isEmpty() && currentIndex != 3 ){
                currentIndex = 3;
                if( lblpath3.getText().endsWith(".mp4"))
                    videoDisplay( lblpath3.getText() );
                else
                    imageDisplay( lblpath3.getText() );
            }
        }catch(Exception ex){}
    }
    
    private void imageDisplay( String fileName ) throws Exception{
        
        BufferedImage sourceFile = ImageIO.read( new java.io.File( fileName ) );
        lbldisplay.setIcon( new ImageIcon( ScaleFit.scaleFit(sourceFile, 600) ));
        lbldisplay.revalidate( );
        lbldisplay.repaint( );
    }
    

    private void videoDisplay( String fileName ){
        
        try{
            if( videoPlayer != null ){
                videoPlayer.setStop( true );
            }
            
            videoPlayer = new VideoPlayer();
            videoPlayer.setListener(new VideoPlayer.VideoPlayerListener() {
                @Override
                public void onPlay(opencv_core.Mat colorImage) {
                    BufferedImage image = new Java2DFrameConverter( ).convert( 
                            new OpenCVFrameConverter.ToIplImage().convert( colorImage ) );
                    
                    lbldisplay.setIcon( new ImageIcon( image ));
                    lbldisplay.revalidate( );
                    lbldisplay.repaint( );
                }

                @Override
                public void onStatus(String status) {
                    HumanDistance.this.status = status;
                    System.out.println("Video player status=" + HumanDistance.this.status);
                    if( status.equals(VideoPlayer.STATUS_FINISHED) || status.equals(VideoPlayer.STATUS_FAILED))
                        currentIndex = 0;
                }
            });
            videoPlayer.initialize( fileName );
            videoPlayer.start( );
        }catch(Exception ex){ex.printStackTrace();}
    }
    
    private void setValue(){
                
        a1Start = Float.parseFloat( txt1start.getText());
        a1End = Float.parseFloat( txt1end.getText());

        a2Start = Float.parseFloat( txt2start.getText());
        a2End = Float.parseFloat( txt2end.getText());

        a3Start = Float.parseFloat( txt3start.getText());
        a3End = Float.parseFloat( txt3end.getText());
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jFileChooser1 = new javax.swing.JFileChooser();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        lbldisplay = new javax.swing.JLabel();
        lbldistance = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        txt2start = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        txt2end = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        btnbrowse2 = new javax.swing.JButton();
        lblpath2 = new javax.swing.JLabel();
        btnok2 = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txt1start = new javax.swing.JTextField();
        txt1end = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        btnbrowse1 = new javax.swing.JButton();
        lblpath1 = new javax.swing.JLabel();
        btnok1 = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jLabel9 = new javax.swing.JLabel();
        txt3start = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        txt3end = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        btnbrowse3 = new javax.swing.JButton();
        lblpath3 = new javax.swing.JLabel();
        btnok3 = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jLabel13 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        lbldisplay.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lbldisplay.setIcon(new javax.swing.ImageIcon(getClass().getResource("/camera.png"))); // NOI18N
        lbldisplay.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        lbldisplay.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        lbldistance.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        lbldistance.setText("Distance:");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lbldisplay, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(lbldistance, javax.swing.GroupLayout.DEFAULT_SIZE, 583, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(lbldisplay, javax.swing.GroupLayout.DEFAULT_SIZE, 447, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lbldistance, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jTabbedPane1.addTab("Dispaly", jPanel1);

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Action 2"));

        jLabel5.setText("Distance range:");

        txt2start.setText("3");

        jLabel6.setText("ft");

        txt2end.setText("5");
        txt2end.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                txt2endActionPerformed(evt);
            }
        });

        jLabel7.setText("ft");

        jLabel8.setText("Display(Image,Video):");

        btnbrowse2.setText("Browse");
        btnbrowse2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnbrowse2ActionPerformed(evt);
            }
        });

        lblpath2.setText("Path:");

        btnok2.setText("OK");
        btnok2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnok2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel3Layout.createSequentialGroup()
                                .addComponent(txt2start, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(txt2end, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(btnbrowse2))
                        .addGap(0, 243, Short.MAX_VALUE))
                    .addComponent(lblpath2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel3Layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(btnok2)))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jLabel6)
                    .addComponent(txt2start, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7)
                    .addComponent(txt2end, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(btnbrowse2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblpath2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(btnok2))
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Action 1"));

        jLabel1.setText("Distance range:");

        jLabel2.setText("ft");

        txt1start.setText("7");

        txt1end.setText("10");

        jLabel3.setText("ft");

        jLabel4.setText("Display(Image,Video):");

        btnbrowse1.setText("Browse");
        btnbrowse1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnbrowse1ActionPerformed(evt);
            }
        });

        lblpath1.setText("Path:");

        btnok1.setText("OK");
        btnok1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnok1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblpath1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addComponent(txt1start, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(txt1end, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(btnbrowse1))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(btnok1)))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(txt1start, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel3)
                    .addComponent(txt1end, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(btnbrowse1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblpath1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(btnok1))
        );

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("Action 3"));

        jLabel9.setText("Distance range:");

        txt3start.setText("1");

        jLabel10.setText("ft");

        txt3end.setText("2");

        jLabel11.setText("ft");

        jLabel12.setText("Display(Image,Video):");

        btnbrowse3.setText("Browse");
        btnbrowse3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnbrowse3ActionPerformed(evt);
            }
        });

        lblpath3.setText("Path:");

        btnok3.setText("OK");
        btnok3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnok3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addComponent(txt3start, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(txt3end, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(btnbrowse3))
                        .addGap(0, 243, Short.MAX_VALUE))
                    .addComponent(lblpath3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(btnok3)))
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(jLabel10)
                    .addComponent(txt3start, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11)
                    .addComponent(txt3end, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(btnbrowse3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblpath3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(btnok3))
        );

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Settings", jPanel2);

        jLabel13.setText("Camera Type: USB or IP camera. Installation height: 4ft~5ft. Angle: 20~25 degree");

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel13, javax.swing.GroupLayout.DEFAULT_SIZE, 571, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addComponent(jLabel13)
                .addContainerGap(448, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Camera Notes", jPanel6);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void txt2endActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_txt2endActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_txt2endActionPerformed

    private void btnbrowse1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnbrowse1ActionPerformed
        // TODO add your handling code here:
        selectFile( 1 );
    }//GEN-LAST:event_btnbrowse1ActionPerformed

    private void btnbrowse2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnbrowse2ActionPerformed
        // TODO add your handling code here:
        selectFile( 2 );
    }//GEN-LAST:event_btnbrowse2ActionPerformed

    private void btnbrowse3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnbrowse3ActionPerformed
        // TODO add your handling code here:
        selectFile( 3 );
    }//GEN-LAST:event_btnbrowse3ActionPerformed

    private void btnok1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnok1ActionPerformed
        try {
            // TODO add your handling code here:
            
            BufferedImage sourceFile = ImageIO.read( new java.io.File(lblpath1.getText()) );
            lbldisplay.setIcon( new ImageIcon( ScaleFit.scaleFit(sourceFile, 600) ));
        } catch (IOException ex) {
            Logger.getLogger(HumanDistance.class.getName()).log(Level.SEVERE, null, ex);
        }
        setValue( );
    }//GEN-LAST:event_btnok1ActionPerformed

    private void btnok2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnok2ActionPerformed
        // TODO add your handling code here:
        setValue( );
    }//GEN-LAST:event_btnok2ActionPerformed

    private void btnok3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnok3ActionPerformed
        // TODO add your handling code here:
        setValue( );
    }//GEN-LAST:event_btnok3ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(HumanDistance.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(HumanDistance.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(HumanDistance.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(HumanDistance.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new HumanDistance().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnbrowse1;
    private javax.swing.JButton btnbrowse2;
    private javax.swing.JButton btnbrowse3;
    private javax.swing.JButton btnok1;
    private javax.swing.JButton btnok2;
    private javax.swing.JButton btnok3;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel lbldisplay;
    private javax.swing.JLabel lbldistance;
    private javax.swing.JLabel lblpath1;
    private javax.swing.JLabel lblpath2;
    private javax.swing.JLabel lblpath3;
    private javax.swing.JTextField txt1end;
    private javax.swing.JTextField txt1start;
    private javax.swing.JTextField txt2end;
    private javax.swing.JTextField txt2start;
    private javax.swing.JTextField txt3end;
    private javax.swing.JTextField txt3start;
    // End of variables declaration//GEN-END:variables
}
