/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.autoface.util;

import java.awt.image.BufferedImage;
import java.io.File;
import javax.imageio.ImageIO;
import org.bytedeco.javacpp.opencv_core;
import static org.bytedeco.javacpp.opencv_imgcodecs.IMREAD_ANYCOLOR;
import static org.bytedeco.javacpp.opencv_imgcodecs.imread;
import static org.bytedeco.javacpp.opencv_imgcodecs.imwrite;
import org.bytedeco.javacv.Java2DFrameConverter;
import org.bytedeco.javacv.OpenCVFrameConverter;

/**
 *
 * @author apple
 */
public class ImageSpliter {
    private OpenCVFrameConverter.ToIplImage converter;
    
    public static void main(String[] args) throws Exception{
        opencv_core.Mat testImage = imread("tosplit.jpg", IMREAD_ANYCOLOR);
        ImageSpliter is = new ImageSpliter();
        java.util.List<opencv_core.Mat> lst = is.split(testImage);
        
        for( int i=0; i < lst.size(); i++){
            is.testWrite( lst.get(i), (i+1)+"");
        }
    }
    
    public java.util.List<opencv_core.Mat> split( opencv_core.Mat image ){
        java.util.List<opencv_core.Mat> lst = null;
//        opencv_core.Mat images[] = null;
        converter = new OpenCVFrameConverter.ToIplImage();
        
        try{
            BufferedImage bufImage = new Java2DFrameConverter( ).convert( converter.convert( image ) );
            BufferedImage[] bufImages = split( bufImage );
            if( bufImages == null ) return lst;
            
            lst = new java.util.ArrayList<>();
            lst.add(converter.convertToMat( new Java2DFrameConverter( ).convert(bufImages[0]) ));
            lst.add(converter.convertToMat( new Java2DFrameConverter( ).convert(bufImages[1]) ));
            lst.add(converter.convertToMat( new Java2DFrameConverter( ).convert(bufImages[2]) ));
            lst.add(converter.convertToMat( new Java2DFrameConverter( ).convert(bufImages[3]) ));
            
        }catch(Exception ex){}
        
        
//        try{
//            BufferedImage bufImage = j2Dconverter.convert( converter.convert( image ) );
//            int width = bufImage.getWidth();
//            int height = bufImage.getHeight();
//            BufferedImage b1=bufImage.getSubimage(0, 0,width/2, height/2);
//            ImageIO.write(b1, "jpg", new File("topLeft.jpg"));
//            
//            BufferedImage b2=bufImage.getSubimage(width/2, 0,width/2, height/2);
//            ImageIO.write(b2, "jpg", new File("topRight.jpg"));
//            
//            BufferedImage b3=bufImage.getSubimage(0, height/2,width/2, height/2);
//            ImageIO.write(b3, "jpg", new File("bottomLeft.jpg"));
//            
//            BufferedImage b4=bufImage.getSubimage(width/2, height/2,width/2, height/2);
//            ImageIO.write(b4, "jpg", new File("bottomRight.jpg"));
//            
//        }catch(Exception ex){}
        
//        int rows = image.rows();// height
//        int cols = image.cols();// width
//        
////        opencv_core.Rect topLeft = new opencv_core.Rect(new opencv_core.Point(0, 0), 
////                new opencv_core.Point(cols/2, rows/2));
//        opencv_core.Mat topLeft = new opencv_core.Mat( image, new opencv_core.Rect(new opencv_core.Point(0, 0), 
//                new opencv_core.Point(cols/2, rows/2)) );
//        testWrite(topLeft, "topLeft");
////        opencv_core.Rect topRight = new opencv_core.Rect(new opencv_core.Point(cols/2, 0), 
////                new opencv_core.Point(cols/2, rows/2));
//        opencv_core.Mat topRight = new opencv_core.Mat( image, new opencv_core.Rect(new opencv_core.Point(cols/2, 0), 
//                new opencv_core.Point(cols/2, rows/2)) );
//        testWrite(topRight, "topRight");
////        opencv_core.Rect bottomLeft = new opencv_core.Rect(new opencv_core.Point(0, rows/2), 
////                new opencv_core.Point(cols/2, rows/2));
//        opencv_core.Mat bottomLeft = new opencv_core.Mat( image, new opencv_core.Rect(new opencv_core.Point(0, rows/2), 
//                new opencv_core.Point(cols/2, rows/2)) );
//        testWrite(bottomLeft, "bottomLeft");
////        opencv_core.Rect bottomRight = new opencv_core.Rect(new opencv_core.Point(cols/2, rows/2), 
////                new opencv_core.Point(cols/2, rows/2));
//        opencv_core.Mat bottomRight = new opencv_core.Mat( image, new opencv_core.Rect(new opencv_core.Point(cols/2, rows/2), 
//                new opencv_core.Point(cols/2, rows/2)) );
//        testWrite(bottomRight, "bottomRight");
        return lst;
    }
    
    public BufferedImage[] split( BufferedImage bufImage ){
        BufferedImage[] images=null;
        if( bufImage == null ) return images;
        
        try{
            images = new BufferedImage[4];
            int width = bufImage.getWidth();
            int height = bufImage.getHeight();
            
            images[0] = bufImage.getSubimage(0, 0,width/2, height/2);
//            ImageIO.write(b1, "jpg", new File("topLeft.jpg"));
            
            images[1] =bufImage.getSubimage(width/2, 0,width/2, height/2);
//            ImageIO.write(b2, "jpg", new File("topRight.jpg"));
            
            images[2] =bufImage.getSubimage(0, height/2,width/2, height/2);
//            ImageIO.write(b3, "jpg", new File("bottomLeft.jpg"));
            
            images[3] =bufImage.getSubimage(width/2, height/2,width/2, height/2);
//            ImageIO.write(b4, "jpg", new File("bottomRight.jpg"));
            
        }catch(Exception ex){}
        
        return images;
    }
    private synchronized void testWrite( opencv_core.Mat img, String fileName){
                
        try{
            java.io.File f1 = new java.io.File( fileName+ ".jpg");
            f1.createNewFile();
            imwrite( f1.getAbsolutePath(), img );
        }catch(Exception ex){}
    }
}
