/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.communitycenter.db;

import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.sqlite.SQLiteConfig;

/**
 *
 * @author apple
 */
public class CenterSQLiteManager {
    public static final String DATABASE_URL = "data/face-recognition.db3";
    
    public java.sql.Connection getCommection(){
        
        java.sql.Connection conn=null;
        try {
            Class.forName("org.sqlite.JDBC");
            SQLiteConfig config = new SQLiteConfig();
            config.setBusyTimeout( 1000 * 15 );
            config.setEncoding( SQLiteConfig.Encoding.UTF_8 );
            config.setJournalMode( SQLiteConfig.JournalMode.DELETE );
            config.setCacheSize(-2000);
            config.setJounalSizeLimit(-1);
            config.setMaxPageCount(1073741823);
            config.setPageSize(4096);
            config.enforceForeignKeys(true);
            config.setLockingMode(SQLiteConfig.LockingMode.NORMAL);
            config.setSynchronous(SQLiteConfig.SynchronousMode.FULL);
            
            conn = java.sql.DriverManager.getConnection( "jdbc:sqlite:" + DATABASE_URL, config.toProperties() );
            //conn = java.sql.DriverManager.getConnection( "jdbc:sqlite:" + DATABASE_URL );
        } catch ( Exception ex) {
            Logger.getLogger(CenterSQLiteManager.class.getName()).log(Level.SEVERE, null, ex);
        }
        return conn;
    }
    
        
    public int saveOrupdateVisitor( long id, boolean isUpdate, String data[] ){
        int result = 0;
        
        try{
            String sql = "insert into visitor(name, nrc, addr, ward, city, state, "
                    + "dob, gender, phones, email, utype, recordingtype, "
                    + "countingtype, points, photo, regdate, _id) "
                        + "values(?,?, ?,?, ?,?, ?,?, ?,?, ?,?, ?,?, ?,?, ?)";
            
            if( isUpdate ){
                sql = "UPDATE camera SET name=?, nrc=?, addr=?, ward=?, city=?, state=?, "
                    + "dob=?, gender=?, phones=?, email=?, utype=?, recordingtype=? " 
                    + "countingtype=?, points=?, photo=?" 
                    + " WHERE _id=" + id ;
            }
            
            java.sql.PreparedStatement psmnt = getCommection().prepareStatement ( sql );
            
            psmnt.setString( 1, data[0]);// name
            psmnt.setString( 2,data[1] );//nrc
            psmnt.setString(3, data[2] );// addr
            psmnt.setString(4, data[3] );// ward
            psmnt.setString(5, data[4] );// city
            psmnt.setString(6, data[5] );// state
            psmnt.setDate(7, java.sql.Date.valueOf( data[6] ) );// dob
            psmnt.setString(8, data[7] );// gender
            psmnt.setString(9, data[8] );// phones
            psmnt.setString(10, data[9] );// email
            psmnt.setString(11, data[10] );// utype
            psmnt.setString(12, data[11] );// recordingtype
            psmnt.setString(13, data[12] );// countingtype
            psmnt.setDouble(14, Double.parseDouble( data[13] ) );// points
            psmnt.setBytes( 15, getImage(data[14]) ); // photo
            
            if( !isUpdate ){
                psmnt.setDate(16, new java.sql.Date( System.currentTimeMillis() ));// regdate
                psmnt.setLong(17, id );// id
            }
            
            result = psmnt.executeUpdate( );
            psmnt.close( );
            close();
            
        }catch(Exception ex){ex.printStackTrace();}
        
        return result;
    }
       
    public java.util.List<Visitor> getVisitorData( long id, String customSQL ){
        java.util.List<Visitor> data = new java.util.ArrayList<>();
        
        try{
            String sql = "select * from visitor";
            if( id > 0 ) sql +=" where _id=" + id;
            
            if( customSQL != null && !customSQL.isEmpty())
                sql = customSQL;
            
            
            java.sql.PreparedStatement statement = getCommection().prepareStatement( sql );
            java.sql.ResultSet rs = statement.executeQuery();
            while( rs.next()){
                String strData[] = new String[]{
                    rs.getLong("_id")+"",
                    rs.getString("name"),
                    rs.getString("nrc")+"",
                    rs.getString("addr"),
                    rs.getString("ward")+"",
                    rs.getString("city"),
                    rs.getString("state"),
                    rs.getDate("dob").getTime()+"",
                    rs.getString("gender"),
                    rs.getString("phones"),
                    rs.getString("email"),
                    rs.getString("utype"),
                    rs.getDate("regdate").getTime()+"",
                    rs.getString("recordingtype"),
                    rs.getString("countingtype"),
                    rs.getDouble("points") + ""
                };
                
                byte photo[] = rs.getBytes("photo");
                        
//                        javax.swing.ImageIcon icon = new javax.swing.ImageIcon( dbimg );
                javax.swing.ImageIcon images[] = new javax.swing.ImageIcon[3];
                if( photo != null ) images[0] = new javax.swing.ImageIcon( photo );
                data.add( new Visitor(strData, images) );
            }
            
            rs.close();
            close();
            
        }catch(Exception ex){}
        
        return data;
    }
    
        
    public Long getLastVisitorId( ){
        long id = 0;
        
        try{
            String sql = "select _id from visitor"
                    +" ORDER BY _id DESC LIMIT 1";
            
            java.sql.PreparedStatement statement = getCommection().prepareStatement(sql);
            java.sql.ResultSet rs = statement.executeQuery();
            while( rs.next()){
                    id = rs.getLong("_id");
            }
            rs.close();
            close();
        }catch(Exception ex){}
        
        return id;
    }
    
    public int saveOrupdateCamera( long id, boolean isUpdate, String data[] ){
        int result = 0;
        
//                    rs.getBoolean("alert") + "",
//                    rs.getBoolean("counter") + "",
//                    rs.getInt("countermode") + "",
//                    rs.getString("selectedobjects"),
//                    rs.getBoolean("demograph") + ""
                            
        try{// name, usbindex or remoteurl, buildinglevel, position, capturemode, status, id
            String sql = "insert into camera(name, usbindex, remoteurl, buildinglevel, building, "
                    + "location, position, capturemode, gatenumber, description, status,"
                    +"alert, counter, countermode, selectedobjects, demograph,"
                    + " regdate, _id) "
                        + "values(?,?, ?,?, ?,?, ?,?, ?,?, ?,?,?, ?,?,?, ?,?)";
            //String[] {name,usbindex,remoteurl,buildinglevel,building,location,position,capturemode,gatenumber,description,status};
            if( isUpdate ){
                sql = "UPDATE camera SET name=?, usbindex=?, remoteurl=?, buildinglevel=?, building=?, "
                    + "location=?, position=?, capturemode=?, gatenumber=?, description=?, status=?,"
                    +"alert=?, counter=?, countermode=?, selectedobjects=?, demograph=?"
                    + " WHERE _id=" + id ;
            }
            
            java.sql.PreparedStatement psmnt = getCommection().prepareStatement ( sql );
            psmnt.setString( 1, data[0]);// name
            psmnt.setInt( 2, Integer.parseInt(data[1]) );//usb index
            psmnt.setString(3, data[2] );// url
            psmnt.setInt(4, Integer.parseInt(data[3]) );// building level
            psmnt.setString(5, data[4] );// building name
            psmnt.setString(6, data[5] );// location
            psmnt.setString(7, data[6] );// position
            psmnt.setString(8, data[7] );// capturemode
            psmnt.setString(9, data[8] );// gatenumber
            psmnt.setString(10, data[9] );// description
            psmnt.setBoolean(11, Boolean.parseBoolean( data[10]) );// status 
            
            psmnt.setBoolean(12, Boolean.parseBoolean( data[11]) );// alert 
            psmnt.setBoolean(13, Boolean.parseBoolean( data[12]) );// counter 
            psmnt.setInt(14, Integer.parseInt( data[13]) );// countermode 
            psmnt.setString(15,  data[14] );// selectedobjects 
            psmnt.setBoolean(16, Boolean.parseBoolean( data[15]) );// demograph 
            
            if( !isUpdate ){
                psmnt.setDate(17, new java.sql.Date( System.currentTimeMillis() ));// regdate
                psmnt.setLong(18, id );// id
            }
            
            result = psmnt.executeUpdate( );
            psmnt.close( );
            close();
            
        }catch(Exception ex){ex.printStackTrace();}
        
        return result;
    }
    
    public java.util.List<String[]> getCameraData( long id, String customSQL ){
        java.util.List<String[]> data = new java.util.ArrayList<>();
        
        try{
            String sql = "select * from camera";
            if( id > 0 ) sql +=" where _id=" + id;
            
            if( customSQL != null && !customSQL.isEmpty())
                sql = customSQL;
            
            java.sql.PreparedStatement statement = getCommection().prepareStatement(sql);
            java.sql.ResultSet rs = statement.executeQuery();
            while( rs.next()){
                String strData[] = new String[]{ 
                    rs.getLong("_id")+"",
                    rs.getString("name"),
                    rs.getInt("usbindex")+"",
                    rs.getString("remoteurl"),
                    rs.getInt("buildinglevel")+"",
                    rs.getString("building"),
                    rs.getString("location"),
                    rs.getString("position"),
                    rs.getString("capturemode"),
                    rs.getString("gatenumber"),
                    rs.getDate("regdate").getTime()+"",
                    rs.getString("description"),
                    rs.getBoolean("status") + "",
                    rs.getBoolean("alert") + "",
                    rs.getBoolean("counter") + "",
                    rs.getInt("countermode") + "",
                    rs.getString("selectedobjects"),
                    rs.getBoolean("demograph") + ""
                };
                data.add(strData);
            }
            
            
            rs.close();
            close();
            
        }catch(Exception ex){}
        
        return data;
    }
    
    public String[] getLastVisitingRecord( String vID, String cID ){
        java.util.List<String[]> data = new java.util.ArrayList<>();
        
        // today
//        java.util.Calendar ca = java.util.Calendar.getInstance();
//        ca.add(java.util.Calendar.DAY_OF_MONTH, -1);
        // sql = entrytime > ca.getTimeInMillis()
        java.util.Date date = new java.util.Date();
        java.time.Instant inst = date.toInstant();
        java.time.LocalDate localDate = inst.atZone(java.time.ZoneId.systemDefault()).toLocalDate();
        java.time.Instant dayInst = localDate.atStartOfDay(java.time.ZoneId.systemDefault()).toInstant();
        java.util.Date day = java.util.Date.from(dayInst);
        try{
            String sql = "select _id, countnumber, visitingpurpose from visitingrecord"
                    + " where entrytime > " + day.getTime()
                    + " AND visitorid=" + vID
                    +" AND cameraid=" + cID
                    +" ORDER BY _id DESC LIMIT 1";
            
            java.sql.PreparedStatement statement = getCommection().prepareStatement(sql);
            java.sql.ResultSet rs = statement.executeQuery();
            while( rs.next()){
                String strData[] = new String[]{ 
                    rs.getLong("_id")+"",
                    rs.getInt("countnumber")+"",
                    rs.getString("visitingpurpose")
                };
                data.add( strData );
            }
            rs.close();
            close();
        }catch(Exception ex){}
        
        if( data.isEmpty()) return null;
        else return data.get(0);
    }
        
    public int saveOrupdateRecording( long id, boolean isUpdate, String data[] ){
        int result = 0;
        java.sql.PreparedStatement psmnt;
        
        try{
            if( isUpdate ){
                String sql = "UPDATE visitingrecord SET exittime=?, countnumber=?, confidence=?"
                    + " WHERE _id=" + id ;
                
                psmnt = getCommection().prepareStatement ( sql );
                psmnt.setDate(1, new java.sql.Date( System.currentTimeMillis() ) );// exittime
                psmnt.setInt(2, Integer.parseInt(data[0]) );// countnumber
                psmnt.setDouble(3, Double.parseDouble(data[1]));
                
            }else{
                String sql = "insert into visitingrecord(visitorid, cameraid, entrytime, exittime, countnumber, "
                    + "visitingpurpose, confidence, _id) "
                        + "values(?,?, ?,?, ?,?, ?,?)";
                
                psmnt = getCommection().prepareStatement ( sql );
                psmnt.setLong( 1, Long.parseLong( data[0] ) );// visitorid
                psmnt.setLong( 2, Long.parseLong( data[1] ) );//cameraid
                psmnt.setDate(3, new java.sql.Date( System.currentTimeMillis() ) );// entrytime
                psmnt.setDate(4, new java.sql.Date( System.currentTimeMillis() ) );// exittime
                psmnt.setInt(5, 1 );// countnumber
                psmnt.setString(6, data[2] );// visitingpurpose
                psmnt.setDouble(7, Double.parseDouble(data[3]));
                psmnt.setLong(8, id );// id
            }
                        
            result = psmnt.executeUpdate( );
            psmnt.close( );
            close();
            
        }catch(Exception ex){ ex.printStackTrace();}
        
        return result;
    }
      
    public String[] getLastCameraRecord( String cID, String objectname, String agegroup, String gendergroup, String emogroup ){
        java.util.List<String[]> data = new java.util.ArrayList<>();
        
        // today
//        java.util.Calendar ca = java.util.Calendar.getInstance();
////        ca.add(java.util.Calendar.DAY_OF_MONTH, -1); last 24 hours
//        java.util.Date d = new java.util.Date();
//        ca.set( d.getYear()+1900, d.getMonth(), d.getDate(), 0, 0, 0 );
//        java.util.Date date = new java.util.Date(ca.getTimeInMillis());
        
        java.util.Date date = new java.util.Date();
        java.time.Instant inst = date.toInstant();
        java.time.LocalDate localDate = inst.atZone(java.time.ZoneId.systemDefault()).toLocalDate();
        java.time.Instant dayInst = localDate.atStartOfDay(java.time.ZoneId.systemDefault()).toInstant();
        java.util.Date day = java.util.Date.from(dayInst);
        
        try{
            String sql = "select _id, objcount, objectname from camerarecord"
                    + " where counton > " + day.getTime()
                    + " AND objectname='" + objectname
                    + "' AND agegroup='" + agegroup
                    + "' AND gendergroup='" + gendergroup
                    + "' AND emogroup='" + emogroup
                    + "' AND cameraid=" + cID
                    +" ORDER BY _id DESC LIMIT 1";
            
            java.sql.PreparedStatement statement = getCommection().prepareStatement(sql);
            java.sql.ResultSet rs = statement.executeQuery();
            while( rs.next()){
                String strData[] = new String[]{ 
                    rs.getLong("_id")+"",
                    rs.getInt("objcount")+"",
                    rs.getString("objectname")
                };
                data.add( strData );
            }
            rs.close();
            close();
        }catch(Exception ex){ex.printStackTrace();}
        
        if( data.isEmpty()) return null;
        else return data.get(0);
    }
         
    public int saveOrupdateCameraRecording( long id, boolean isUpdate, String data[] ){
        int result = 0;
        java.sql.PreparedStatement psmnt;
        
        try{
            if( isUpdate ){
                String sql = "UPDATE camerarecord SET lastknown=?, objcount=?"
                    + " WHERE _id=" + id ;
                
                psmnt = getCommection().prepareStatement ( sql );
                psmnt.setDate(1, new java.sql.Date( System.currentTimeMillis() ) );// lastknown
                psmnt.setInt(2, Integer.parseInt(data[0]) );// countnumber
                
            }else{
                String sql = "insert into camerarecord( cameraid, lastknown, objectname, objcount, agegroup, gendergroup, emogroup, counton, _id) "
                        + "values(?,?, ?,?, ?,?, ?,?, ?)";
                
                psmnt = getCommection().prepareStatement ( sql );
                psmnt.setLong( 1, Long.parseLong( data[0] ) );// cameraid
                psmnt.setDate(2, new java.sql.Date( System.currentTimeMillis() ) );// lastknown
                psmnt.setString(3, data[1] );// object name
                psmnt.setInt(4, Integer.parseInt(data[2]) );// count
                psmnt.setString(5, data[3] );// age
                psmnt.setString(6, data[4] );// gender
                psmnt.setString(7, data[5] );// emotion
                
                psmnt.setDate(8, new java.sql.Date( System.currentTimeMillis() ) );// counton
                psmnt.setLong(9, id );// id
            }
                        
            result = psmnt.executeUpdate( );
            psmnt.close( );
            close();
            
        }catch(Exception ex){ ex.printStackTrace();}
        
        return result;
    }
    
    
    public java.util.Map<Integer,Object[]> getVisitorsByFloor( ){
        
        java.util.Map<Integer,Object[]> cams = getCameraByFloor();
        try{
                        
            for( java.util.Map.Entry<Integer,Object[]> entry : cams.entrySet()){
                
                for( int i=0; i < 12; i++){
                    java.util.Calendar ca = java.util.Calendar.getInstance();
                    java.util.Date d = new java.util.Date();
                    ca.set( d.getYear()+1900, i, 1, 0, 0, 0 );
                    java.util.Date date = new java.util.Date(ca.getTimeInMillis());
                    long d1 = date.getTime();
                    ca.set( d.getYear()+1900, i+1, 1, 0, 0, 0 );
                    date = new java.util.Date(ca.getTimeInMillis());
                    long d2 = date.getTime();
        
                    try{
                    String customSQL = "select sum(objcount) from [camerarecord] where [cameraid] IN(" + (String)(entry.getValue()[0])+") AND counton > " + d1 +" AND counton<" + d2;
                    
                    java.sql.PreparedStatement statement = getCommection().prepareStatement( customSQL );
                    java.sql.ResultSet rs = statement.executeQuery( );
                    while( rs.next()){
                        int sum = rs.getInt(1);
                        entry.getValue()[i+1] = sum;
                        //System.out.println( sum );
                    }
                    rs.close();
                    
                    }catch(Exception ex){}
                }
            }
             close();
        }catch(Exception ex){ex.printStackTrace();}
       
        return cams;
    }
    
    public java.util.Map<Integer,Object[]> getCameraByFloor(){
        java.util.Map<Integer,Object[]> cams = new java.util.TreeMap<>();
        try{
            String customSQL = "select _id, buildinglevel from camera order by buildinglevel";
            java.sql.PreparedStatement statement = getCommection().prepareStatement( customSQL );
            java.sql.ResultSet rs = statement.executeQuery( );
                        
            while( rs.next()){
                long id = rs.getLong(1);
                int buildinglevel = rs.getInt(2);
                if(cams.get(buildinglevel) == null ){
                    Object o[] = new Object[13];
                    o[0] = id+"";
                    cams.put( buildinglevel, o);
                }else{
                    Object o[] = cams.get(buildinglevel);
                    o[0] = (String)o[0] + "," + id + "";
                    cams.replace( buildinglevel, o);
                }
//                System.out.println(rs.getObject(1).toString()+","+ rs.getObject(2).toString());
            }
            rs.close();
            close();
            
        }catch(Exception ex){}
        
        return cams;
    }
    
    public java.util.Map<String,Integer> getByAge(){
        java.util.Map<String,Integer> cams = new java.util.TreeMap<>();
        
        try{       
            
            String customSQL = "select sum(objcount), agegroup from camerarecord group by agegroup";
            java.sql.PreparedStatement statement = getCommection().prepareStatement( customSQL );
            java.sql.ResultSet rs = statement.executeQuery( );
            while( rs.next()){
                cams.put( rs.getString(2), rs.getInt(1) );
            }
            rs.close();
            close();
            
        }catch(Exception ex){ex.printStackTrace();}
        return cams;
    }
    
        
    public java.util.Map<String,Integer> getByGender(){
        java.util.Map<String,Integer> cams = new java.util.TreeMap<>();
        
        try{       
            
            String customSQL = "select sum(objcount), gendergroup from camerarecord group by gendergroup";
            java.sql.PreparedStatement statement = getCommection().prepareStatement( customSQL );
            java.sql.ResultSet rs = statement.executeQuery( );
            while( rs.next()){
                cams.put( rs.getString(2), rs.getInt(1) );
            }
            rs.close();
            close();
            
        }catch(Exception ex){ex.printStackTrace();}
        return cams;
    }
    /**
     * extracting data with SQL command, should close database connection "call close()" after processing
     * @param customSQL
     * @return ResultSet with data
     */
    public java.sql.ResultSet getData( String customSQL ){
        java.sql.ResultSet rs = null;
        
        try{
            java.sql.PreparedStatement statement = getCommection().prepareStatement( customSQL );
            rs = statement.executeQuery( );
        }catch( Exception ex){ ex.printStackTrace();}
        
        return rs;
    }
    
    public int execute( String sql){
        int result = -1;
        try{
                Statement stmt = getCommection().createStatement();
                result = stmt.executeUpdate(sql);
                stmt.close();
                close();
        }catch ( Exception ex){
            System.out.println( ex.toString() + " execute ( )");
        }
        
        return result;
    }
    
    public void close() throws SQLException{
        getCommection().close();
    }
    
    private byte[] getImage(String file){
        return getImage(new java.io.File(file));
    }
    private byte[] getImage(java.io.File file){
//        psmnt.setBytes( 9, getImage(image) ); // save the new image
//javax.swing.ImageIcon icon = new javax.swing.ImageIcon( dbimg );

        byte x[]=null;
        
        try{
            if( file == null ) return null;
            
            FileInputStream fis = new FileInputStream( file );
            ByteArrayOutputStream bos = new ByteArrayOutputStream();
            byte[] buf = new byte[1024];

            try{
                for ( int readNum; (readNum = fis.read(buf))  != -1;){
                    bos.write(buf, 0, readNum);
                }
                x = bos.toByteArray();
                bos.close();
            }catch ( Exception ex){

            }
            
        }catch(Exception ex){
            System.out.println(ex.toString());
        }
        
        return x;
    }
}
/*
CREATE TABLE [camerarecord](
  [_id] BIGINT PRIMARY KEY NOT NULL UNIQUE, 
  [cameraid] BIGINT NOT NULL, 
  [lastknown] DATETIME, 
  [objcount] INT, 
  [counton] DATETIME, 
  [objectname] TEXT, 
  [agegroup] TEXT, 
  [gendergroup] TEXT, 
  [emogroup] TEXT);

CREATE TABLE [visitor](
  [_id] BIGINT CONSTRAINT [sqlite_autoindex_visitor_1] PRIMARY KEY NOT NULL ON CONFLICT ABORT, 
  [name] TEXT, 
  [nrc] TEXT, 
  [addr] TEXT, 
  [ward] TEXT, 
  [city] TEXT, 
  [state] TEXT, 
  [dob] DATE, 
  [gender] TEXT, 
  [phones] TEXT, 
  [email] TEXT, 
  [utype] TEXT, 
  [regdate] DATETIME, 
  [recordingtype] TEXT, 
  [countingtype] TEXT, 
  [points] DECIMAL, 
  [photo] BLOB, 
  [cascadeimage] BLOB, 
  [caffeimage] BLOB, 
  [lastknown] DATETIME, 
  [note] TEXT);

CREATE TABLE [visitingrecord](
  [_id] BIGINT PRIMARY KEY, 
  [visitorid] BIGINT, 
  [cameraid] BIGINT, 
  [entrytime] DATETIME, 
  [exittime] DATETIME, 
  [countnumber] INT, 
  [visitingpurpose] TEXT, 
  [confidence] DECIMAL);

CREATE TABLE [camera] (
  [_id] BIGINT NOT NULL, 
  [name] TEXT, 
  [usbindex] INT, 
  [remoteurl] TEXT, 
  [buildinglevel] INT, 
  [building] TEXT, 
  [location] TEXT, 
  [position] TEXT, 
  [capturemode] TEXT, 
  [gatenumber] TEXT, 
  [regdate] DATETIME, 
  [description] TEXT, 
  [status] BOOLEAN, 
  CONSTRAINT [sqlite_autoindex_camera_1] PRIMARY KEY ([_id]));

*/