/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.ml.vision.communitycenter.db;

import java.awt.Component;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

/**
 *
 * @author kyithar
 */
public class ResultSetDefaultModel extends DefaultTableModel{
    private ResultSet rs;
    private ResultSetMetaData rsmd;
    private String header[];
    private boolean allowCellEdit = false;
    

    public ResultSetDefaultModel(String header[]){
        this.header = header;
    }
    public ResultSetDefaultModel(ResultSet rs){
        this.rs = rs;
            try
            {
              rsmd = rs.getMetaData();
              int cols = getColumnCount(); 
              while (rs.next())
              {
                Object[] row = new Object[cols];
                for (int j = 0; j < row.length; j++)
                    row[j] = String.valueOf(rs.getObject(j + 1)).trim();
                    addRow(row);
              }rs.close();
            }
            catch(SQLException e)
            {
              System.out.println("Error " + e);
            }
    }
    public ResultSetDefaultModel(ResultSet rs, String header[]){
        this.rs = rs;
        this.header = header;
        
            try
            {
              rsmd = rs.getMetaData();
              int cols = getColumnCount();
              while (rs.next())
              {
                Object[] row = new Object[cols];
                for (int j = 0; j < row.length; j++)
                    row[j] = String.valueOf(rs.getObject(j + 1)).trim();
                    addRow(row);
              }rs.close();
            }
            catch(SQLException e)
            {
              System.out.println("Error " + e);
            }
    }
    /**
     * Return the value list of Objects (Object[]) at the specified row.
     * If the row position is not valid return null value.
     * @param row specified row position
     * @return value Object[] that includes list of Objects at the specified row
     */
    public Object[] getRowAt(int row){
        if(row >= getRowCount() || row<0) return null;
        
        Object[] rowData = new Object[getColumnCount()];
        
            for (int i=0; i < rowData.length; i++)
                rowData[i] = getValueAt(row, i);

        return rowData;
    }
    public int getRowIndex(int column, Object value){
        int index = -1;
        if( column >= getColumnCount() || column<0 ) return -1;

        for( int i=0; i < getRowCount(); i++ ){
            if( getValueAt(i, column).toString().equalsIgnoreCase(value.toString()) ){
                index = i; break;
            }
        }
        return index;
    }
    @Override
    public String getColumnName(int c)
      {
        try
        {
            if(header !=null && header.length>0)
                return header[c];
            else
            return rsmd.getColumnName(c + 1);
        }
        catch(SQLException e)
        {
          System.out.println("Error " + e);
          return "";
        }
      }
    @Override
    public int getColumnCount()
  {
    try
    {
        if(header !=null && header.length>0)
            return header.length;
        else
            return rsmd.getColumnCount();
    }
    catch(SQLException e)
    {
      System.out.println("Error " + e);
      return 0;
    }
  }
    @Override
    public boolean isCellEditable(int rowIndex, int columnIndex) {
        return isAllowCellEdit();
    }

    public boolean isAllowCellEdit() {
        return allowCellEdit;
    }

    public void setAllowCellEdit(boolean allowCellEdit) {
        this.allowCellEdit = allowCellEdit;
    }

    
    public void intervalRenderer(javax.swing.JTable tbl, Integer colWidth[]){
        try{
            if(tbl == null) return;

            TableColumnModel tcm_type = tbl.getColumnModel();
            for (int i=0; i< getColumnCount(); i++){
                
                TableColumn tc_type = tcm_type.getColumn(i);
                tc_type.setCellRenderer(new DefaultTableCellRenderer(){

                @Override
                public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
                        boolean hasFocus, int row, int column) {
                        setValue(value);

                    if(isSelected){
                        setBackground(new java.awt.Color(204,204,255));
                        setForeground(new java.awt.Color(255, 255, 255));
                    }
                    else{
                            if(row%2 == 0)
                                setBackground(new java.awt.Color(250, 240, 240));
                            else
                                setBackground(new java.awt.Color(255, 255, 255));

                        setForeground(new java.awt.Color(0, 0, 0));
                    }
                    return this;
                }
            });

            if(colWidth != null)
                tc_type.setPreferredWidth(colWidth[i]);

            }

        }catch(Exception ex){

        }
    }
    public void intervalRenderer(javax.swing.JTable tbl){
        intervalRenderer(tbl, null);
    }

    public void removeAll(){
        if(getRowCount()>0){
            for (; getRowCount()>0;){
                removeRow(0);
            }
        }
    }
    
}
