/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.communitycenter.ui.charts;

import com.ml.vision.communitycenter.db.CenterSQLiteManager;
import org.knowm.xchart.SwingWrapper;
import org.knowm.xchart.XYChart;
import org.knowm.xchart.XYChartBuilder;
import org.knowm.xchart.XYSeries;
import org.knowm.xchart.XYSeries.XYSeriesRenderStyle;
import org.knowm.xchart.style.Styler;
import org.knowm.xchart.style.Styler.LegendPosition;
import org.knowm.xchart.style.markers.SeriesMarkers;

/**
 *
 * @author apple
 */


/**
 * Combination Line & Area Chart
 *
 * <p>Demonstrates the following:
 *
 * <ul>
 *   <li>Combination of Line and Area series
 *   <li>Axis Label Alignment
 *   <li>Ensuring a chart axis on a tick
 *   <li>Turning off series markers
 */
public class AreaChart03 implements ExampleChart<XYChart> {

    private CenterSQLiteManager sqlManager;
    private int[] xAges = new int[] {
          1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };
  public static void main(String[] args) {

    ExampleChart<XYChart> exampleChart = new AreaChart03( null );
    XYChart chart = exampleChart.getChart();
    new SwingWrapper<XYChart>(chart).displayChart();
  }

  public AreaChart03(CenterSQLiteManager sqlManager){
      this.sqlManager = sqlManager;
  }
  @Override
  public XYChart getChart() {

    // Create Chart
    XYChart chart =
        new XYChartBuilder()
            .width(1200)
            .height(300)
            .title("Monthly Visitors")
            .xAxisTitle("Month")
            .yAxisTitle("Visitors")
            .build();

    // Customize Chart
    chart.getStyler().setLegendPosition(LegendPosition.InsideN);
    chart.getStyler().setDefaultSeriesRenderStyle(XYSeriesRenderStyle.Line );
    chart.getStyler().setYAxisLabelAlignment(Styler.TextAlignment.Right);
    chart.getStyler().setYAxisDecimalPattern("#,###.##");
    chart.getStyler().setPlotMargin(0);
    chart.getStyler().setPlotContentSize(.95);

      try{
          java.util.Map<Integer,Object[]> cams = sqlManager.getVisitorsByFloor( );
          
        for( java.util.Map.Entry<Integer,Object[]> entry : cams.entrySet()){
            
            int floor = entry.getKey();
            int[] floorData = new int[12];
            for( int i=1; i < entry.getValue().length; i++){
                Object o = entry.getValue()[i];
                floorData[i-1] = Integer.parseInt(o.toString());
                //System.out.println( "Floor-"+entry.getKey() +", Month-"+ i +" = "+  o.toString());
            }
            String lagend = "";
            if( floor == 0)
                lagend = "Ground";
            else if( floor == 1)
                lagend = "1st";
            else if( floor == 2)
                lagend = "2nd";
            else if( floor == 3)
                lagend = "3rd";
            else
                lagend = floor + "th";
            
            chart.addSeries( lagend + " floor", xAges, floorData );
        }
      }catch(Exception e){e.printStackTrace();};
      
    double[] yGroundFloor =
        new double[] {
          0, 0, 0, 0, 0, 0, 0, 0, 8449, 8694, 907, 887, 
          8654, 8430, 8196, 7953, 770, 744, 719, 0, 0, 0,
          0, 0
//                , 565385, 540002, 514620, 489380, 465149, 441817, 419513, 398465, 377991,
//          358784, 340920, 323724, 308114, 293097, 279356, 267008, 254873
        };

    double[] yFirstFloor =
        new double[] {
          0, 0, 0, 0, 0, 0, 0, 0, 1440, 1550,
          1647, 1705, 1705, 1710, 170, 168, 16, 0, 0, 0,
          0, 0, 0, 0
//                , 1641842, 1653758, 1636317, 1620725, 1589985, 1586451,
//          1559507, 1544234, 1529700, 1507496, 1474907, 1422169, 1415079, 1346929, 1311689, 1256114,
//          1221034
        };

    double[] ySecondFloor =
        new double[] {
          0, 0, 0, 0, 0, 0, 0, 0, 1246, 1329,
          1424, 1424, 1421, 1397, 1381, 336, 136, 0, 0, 0,
          0, 0, 0, 0
//                , 1211335, 1191953, 1159689, 1117412, 1078875, 1021020,
//          974933, 910189, 869154, 798476, 744934, 674501, 609237, 524516, 442234, 343960, 257025
        };

    double[] yThirdFloor =
        new double[] {
          0, 0, 0, 0, 0, 0, 0, 0, 1054, 1118,
          1194, 1185, 1175, 1156, 1132, 1094, 106, 0, 0, 0,
          0, 0, 0, 0
//                , 783318, 739751, 696201, 638242, 565197, 496959, 421280,
//          358113, 276518, 195571, 109514, 13876, 29, 0, 0, 0, 0
        };
    // @formatter:on

//    XYSeries series = chart.addSeries("Ground floor", xAges, yLiability);
////    series.setXYSeriesRenderStyle(XYSeries.XYSeriesRenderStyle.Area);
////    series.setMarker(SeriesMarkers.NONE);
//
//    chart.addSeries("1st floor", xAges, yPercentile75th);
//    chart.addSeries("2nd floor", xAges, yPercentile50th);
//    chart.addSeries("3rd floor", xAges, yPercentile25th);

    return chart;
  }
}
