/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.communitycenter.ui.charts;

/**
 *
 * @author apple
 */
import java.awt.Color;
import org.knowm.xchart.PieChart;
import org.knowm.xchart.PieChartBuilder;
import org.knowm.xchart.SwingWrapper;
import org.knowm.xchart.style.PieStyler.AnnotationType;
import org.knowm.xchart.style.Styler;

/**
 * Pie Chart Custom Color Palette
 *
 * <p>Demonstrates the following:
 *
 * <ul>
 *   <li>Pie Chart
 *   <li>PieChartBuilder
 *   <li>Custom series palette
 *   <li>Value Annotations
 */
public class PieChart02 implements ExampleChart<PieChart> {

  public static void main(String[] args) {

    ExampleChart<PieChart> exampleChart = new PieChart02();
    PieChart chart = exampleChart.getChart();
    new SwingWrapper<PieChart>(chart).displayChart();
  }

  @Override
  public PieChart getChart() {

    // Create Chart
    PieChart chart =
        new PieChartBuilder()
            .width(400)
            .height(300)
            .title("Regions")
            .theme(Styler.ChartTheme.GGPlot2)
            .build();

    // Customize Chart
    Color[] sliceColors =
        new Color[] {
          new Color(224, 68, 14),
          new Color(230, 105, 62),
          new Color(236, 143, 110),
          new Color(243, 180, 159),
          new Color(246, 199, 182),
          new Color(243, 180, 159),
          new Color(246, 199, 182),
          new Color(224, 68, 14),
          new Color(230, 105, 62),
          new Color(236, 143, 110),
          new Color(243, 180, 159),
          new Color(246, 199, 182),
          new Color(243, 180, 159),
          new Color(246, 199, 182)
        };
    chart.getStyler().setLegendVisible(false);
    chart.getStyler().setSeriesColors(sliceColors);
    chart.getStyler().setAnnotationType(AnnotationType.Label);
    chart.getStyler().setAnnotationDistance(1.15);
    chart.getStyler().setPlotContentSize(.7);
    chart.getStyler().setStartAngleInDegrees(90);
    // chart.getStyler().setDecimalPattern("#0.000");

    // Series
    chart.addSeries("Yangon", 24);
    chart.addSeries("Mandalay", 21);
    chart.addSeries("Sagaing", 39);
    chart.addSeries("Mgew", 17);
    chart.addSeries("Bago", 40);
    chart.addSeries("Irrwaddy", 17);
    chart.addSeries("Tanintharyi", 40);
    
    chart.addSeries("Kachin", 24);
    chart.addSeries("Kaya", 21);
    chart.addSeries("Kayin", 39);
    chart.addSeries("Chin", 17);
    chart.addSeries("Mon", 40);
    chart.addSeries("Rakhine", 17);
    chart.addSeries("Shan", 40);

    return chart;
  }
}
