/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.communitycenter.ui.charts;

/**
 *
 * @author apple
 */
import com.ml.vision.communitycenter.db.CenterSQLiteManager;
import org.knowm.xchart.PieChart;
import org.knowm.xchart.PieChartBuilder;
import org.knowm.xchart.SwingWrapper;
import org.knowm.xchart.style.PieStyler;
import org.knowm.xchart.style.Styler.ChartTheme;

/**
 * Pie Chart GGPlot2 Theme
 *
 * <p>Demonstrates the following:
 *
 * <ul>
 *   <li>Pie Chart
 *   <li>PieChartBuilder
 *   <li>GGPlot2 Theme
 *   <li>Setting start angle
 */
public class PieChart03 implements ExampleChart<PieChart> {

    private CenterSQLiteManager sqlManager;
    
  public static void main(String[] args) {

    ExampleChart<PieChart> exampleChart = new PieChart03( null );
    PieChart chart = exampleChart.getChart();
    new SwingWrapper<PieChart>(chart).displayChart();
  }

    
  public PieChart03(CenterSQLiteManager sqlManager){
      this.sqlManager = sqlManager;
  }
  
  @Override
  public PieChart getChart() {

    // Create Chart
    PieChart chart =
        new PieChartBuilder()
            .width(400)
            .height(300)
            .title("Gender")
            .theme(ChartTheme.GGPlot2)
            .build();

    // Customize Chart
    chart.getStyler().setLegendVisible(false);
    chart.getStyler().setAnnotationDistance(1.15);
    chart.getStyler().setPlotContentSize(.7);
    chart.getStyler().setStartAngleInDegrees(90);
    chart.getStyler().setAnnotationType(PieStyler.AnnotationType.LabelAndPercentage);
    try{
        java.util.Map<String,Integer> cams = sqlManager.getByGender( );
        for( java.util.Map.Entry<String,Integer> entry : cams.entrySet()){
            chart.addSeries( entry.getKey(), entry.getValue());
        }
    }catch(Exception ex){ex.printStackTrace();}
    
    // Series
//    chart.addSeries("Ground", 1500);
//    chart.addSeries("1st Floor", 1300);
//    chart.addSeries("2nd Floor", 1100);
//    chart.addSeries("3rd Floor", 900);

    return chart;
  }
}
