/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.communitycenter.ui.charts;

/**
 *
 * @author apple
 */
import com.ml.vision.communitycenter.db.CenterSQLiteManager;
import org.knowm.xchart.PieChart;
import org.knowm.xchart.PieChartBuilder;
import org.knowm.xchart.PieSeries.PieSeriesRenderStyle;
import org.knowm.xchart.SwingWrapper;
import org.knowm.xchart.style.PieStyler;
import org.knowm.xchart.style.PieStyler.AnnotationType;
import org.knowm.xchart.style.Styler;
import org.knowm.xchart.style.colors.BaseSeriesColors;

/**
 * Pie Chart with Donut Style and sum.
 *
 * <p>Demonstrates the following:
 *
 * <ul>
 *   <li>Donut Chart
 *   <li>PieChartBuilder
 *   <li>XChart Theme
 */
public class PieChart06 implements ExampleChart<PieChart> {
    private CenterSQLiteManager sqlManager;
    
  public static void main(String[] args) {

    ExampleChart<PieChart> exampleChart = new PieChart06( null );
    PieChart chart = exampleChart.getChart();
    new SwingWrapper<PieChart>(chart).displayChart();
  }

    
  public PieChart06(CenterSQLiteManager sqlManager){
      this.sqlManager = sqlManager;
  }
  
  @Override
  public PieChart getChart() {

      
    // Create Chart
    PieChart chart =
        new PieChartBuilder()
            .width(400)
            .height(300)
            .title("Age level")
            .build();


    chart.getStyler().setAnnotationType(AnnotationType.Label);
    chart.getStyler().setAnnotationDistance(.82);
    chart.getStyler().setPlotContentSize(.9);
    chart.getStyler().setDefaultSeriesRenderStyle(PieSeriesRenderStyle.Pie);
    chart.getStyler().setDecimalPattern("#");

    chart.getStyler().setSeriesColors(new BaseSeriesColors().getSeriesColors());

    chart.getStyler().setSumVisible(true);
    chart.getStyler().setSumFontSize(20f);
    
     /*   
    PieChart chart =
        new PieChartBuilder()
            .width(400)
            .height(300)
            .title("Age level")
            .theme(Styler.ChartTheme.GGPlot2)
            .build();

    // Customize Chart
    chart.getStyler().setLegendVisible(false);
    chart.getStyler().setAnnotationDistance(1.15);
    chart.getStyler().setPlotContentSize(.7);
    chart.getStyler().setStartAngleInDegrees(90);
    chart.getStyler().setAnnotationType(PieStyler.AnnotationType.LabelAndPercentage);
*/
    try{
        java.util.Map<String,Integer> cams = sqlManager.getByAge( );
        for( java.util.Map.Entry<String,Integer> entry : cams.entrySet()){
            chart.addSeries( entry.getKey(), entry.getValue());
        }
    }catch(Exception ex){ex.printStackTrace();}
    
    // Series
//    chart.addSeries("0-12", 100);
//    chart.addSeries("13-24", 2222);
//    chart.addSeries("25-40", 3400);
//    chart.addSeries("40-60", 221);
//    chart.addSeries("60+", 100);

    return chart;
  }
}
