/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.communitycenter.ui.v2;


import com.ml.vision.autoface.detection.objects.Yolov3DarkNet;
import com.ml.vision.autoface.detection.objects.Yolov3MobileSSD;
import com.ml.vision.communitycenter.db.CenterSQLiteManager;

/**
 *
 * @author apple
 */
public class CameraRegistration extends javax.swing.JFrame {

    public interface CameraEntryListener {
        public void onChanged( );
    }
    
    
    private java.util.List<String> lstAvailableObjects = new java.util.ArrayList<>();
    private java.util.List<String> lstSelectedObjects = new java.util.ArrayList<>();
    
    private long id = 0;
    private CameraEntryListener listener;
    /**
     * Creates new form CameraRegistration
     */
    public CameraRegistration() {
        initComponents();
        fillObjects( 0 );
        selectedObject();
    }
    public CameraRegistration( String selectedData[] ) {
        initComponents();
        
        id = Long.parseLong( selectedData[0] );
        txtname.setText( selectedData[1] );
        if( selectedData[3] != null && !selectedData[3].isEmpty()){
            rbtnremote.setSelected(true);
            txturl.setText(selectedData[3] );
        }else{
            rbtnusb.setSelected(true);
            txturl.setText(selectedData[2] );
        }
        System.out.println("Register date=" + new java.util.Date(Long.parseLong(selectedData[10])));
        cbobuildinglevel.setSelectedItem( selectedData[4] );
        cboposition.setSelectedItem( selectedData[7] );
        cbocapturefor.setSelectedItem( selectedData[8] );
        txtgatenumber.setText( selectedData[9] );
        txtdescription.setText(selectedData[11]);
        chkenable.setSelected(Boolean.parseBoolean(selectedData[12]));
        
        
        chkstrangeralert.setSelected(Boolean.parseBoolean(selectedData[13]));
        chkobject.setSelected(Boolean.parseBoolean(selectedData[14]));
        if( chkobject.isSelected()){
            rbtnquick.setEnabled(true);
            rbtnlong.setEnabled(true);
            btnselectall.setEnabled(true);
            btnremoveall.setEnabled(true);
            btnselect.setEnabled(true);
            btnremove.setEnabled(true);
        }
        
        if( Integer.parseInt(selectedData[15]) == 1)
            rbtnlong.setSelected(true);
        else
            rbtnquick.setSelected(true);
        
        if( selectedData[16]!= null && !selectedData[16].isEmpty() ){
            String selectedObj [] = selectedData[16].split(",");
            for ( String s : selectedObj)
                lstSelectedObjects.add(s);
            
            selectedObject();
        }
        
        if( Boolean.parseBoolean(selectedData[17])){
            chkgender.setSelected(true);
            chkage.setSelected(true);
            chkemotion.setSelected(true);
        }
        
        btnsave.setText("Update");
        
        //            rs.getLong("_id")+"", 0
//                    rs.getString("name"), 1
//                    rs.getInt("usbindex")+"", 2
//                    rs.getString("remoteurl"), 3
//                    rs.getInt("buildinglevel")+"",4
//                    rs.getString("building"),5
//                    rs.getString("location"),6
//                    rs.getString("position"),7
//                    rs.getString("capturemode"),8
//                    rs.getString("gatenumber"),9
//                    rs.getDate("regdate").toString(),10
//                    rs.getString("description"),11
//                    rs.getBoolean("status") + "" 12

        fillObjects( 0 );
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        txtname = new javax.swing.JTextField();
        jPanel2 = new javax.swing.JPanel();
        rbtnusb = new javax.swing.JRadioButton();
        rbtnremote = new javax.swing.JRadioButton();
        cboposition = new javax.swing.JComboBox<>();
        cbocapturefor = new javax.swing.JComboBox<>();
        txtgatenumber = new javax.swing.JTextField();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtdescription = new javax.swing.JTextArea();
        txturl = new javax.swing.JTextField();
        lblcameratype = new javax.swing.JLabel();
        cbobuildinglevel = new javax.swing.JComboBox<>();
        chkstrangeralert = new javax.swing.JCheckBox();
        jPanel4 = new javax.swing.JPanel();
        chkobject = new javax.swing.JCheckBox();
        jScrollPane2 = new javax.swing.JScrollPane();
        lstAvailable = new javax.swing.JList<>();
        rbtnquick = new javax.swing.JRadioButton();
        rbtnlong = new javax.swing.JRadioButton();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        lstSelected = new javax.swing.JList<>();
        btnselectall = new javax.swing.JButton();
        btnremoveall = new javax.swing.JButton();
        btnselect = new javax.swing.JButton();
        btnremove = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        chkgender = new javax.swing.JCheckBox();
        chkage = new javax.swing.JCheckBox();
        chkemotion = new javax.swing.JCheckBox();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        chkenable = new javax.swing.JCheckBox();
        btnpreview = new javax.swing.JButton();
        btnsave = new javax.swing.JButton();
        btnclose = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Camera Installation");

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jLabel1.setText("Name:");

        jLabel2.setText("Type:");

        jLabel3.setText("Building Level:");

        jLabel4.setText("Position:");

        jLabel5.setText("Capture For:");

        jLabel6.setText("Gate Number:");

        jLabel7.setText("Description:");

        buttonGroup1.add(rbtnusb);
        rbtnusb.setSelected(true);
        rbtnusb.setText("USB");
        rbtnusb.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbtnusbItemStateChanged(evt);
            }
        });

        buttonGroup1.add(rbtnremote);
        rbtnremote.setText("Remote");
        rbtnremote.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbtnremoteItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rbtnusb)
                .addGap(18, 18, 18)
                .addComponent(rbtnremote)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addGap(0, 6, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rbtnusb)
                    .addComponent(rbtnremote)))
        );

        cboposition.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "General", "Entrance", "Exit" }));

        cbocapturefor.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Registration", "Monitoring" }));
        cbocapturefor.setSelectedIndex(1);

        txtdescription.setColumns(20);
        txtdescription.setRows(5);
        jScrollPane1.setViewportView(txtdescription);

        lblcameratype.setText("USB Index:");

        cbobuildinglevel.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10" }));

        chkstrangeralert.setForeground(new java.awt.Color(220, 0, 0));
        chkstrangeralert.setText("Stranger Alert");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 123, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(cboposition, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(cbocapturefor, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(cbobuildinglevel, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 558, Short.MAX_VALUE)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(chkstrangeralert, javax.swing.GroupLayout.PREFERRED_SIZE, 124, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(txtgatenumber))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(lblcameratype, javax.swing.GroupLayout.DEFAULT_SIZE, 123, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(txturl, javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(txtname)
                                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                        .addContainerGap())))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtname, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txturl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblcameratype))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(cbobuildinglevel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(cboposition, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(cbocapturefor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(txtgatenumber, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel7)
                    .addComponent(chkstrangeralert))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(12, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("General", jPanel1);

        jPanel4.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        chkobject.setText("Enable");
        chkobject.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkobjectActionPerformed(evt);
            }
        });

        lstAvailable.setModel(new javax.swing.AbstractListModel<String>() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public String getElementAt(int i) { return strings[i]; }
        });
        jScrollPane2.setViewportView(lstAvailable);

        buttonGroup2.add(rbtnquick);
        rbtnquick.setSelected(true);
        rbtnquick.setText("Quick Mode");
        rbtnquick.setEnabled(false);
        rbtnquick.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnquickActionPerformed(evt);
            }
        });

        buttonGroup2.add(rbtnlong);
        rbtnlong.setText("Long Distance Mode");
        rbtnlong.setEnabled(false);
        rbtnlong.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbtnlongActionPerformed(evt);
            }
        });

        jLabel8.setText("Available Objects");

        jLabel9.setText("Selected Objects");

        jScrollPane3.setViewportView(lstSelected);

        btnselectall.setText("Select All");
        btnselectall.setEnabled(false);
        btnselectall.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnselectallActionPerformed(evt);
            }
        });

        btnremoveall.setText("Remove All");
        btnremoveall.setEnabled(false);
        btnremoveall.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnremoveallActionPerformed(evt);
            }
        });

        btnselect.setText(">>");
        btnselect.setEnabled(false);
        btnselect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnselectActionPerformed(evt);
            }
        });

        btnremove.setText("<<");
        btnremove.setEnabled(false);
        btnremove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnremoveActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(btnremoveall, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnselectall, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnselect, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(btnremove, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addComponent(chkobject, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(rbtnquick))
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addGap(80, 80, 80)))
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addComponent(rbtnlong)
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGap(91, 91, 91)
                                .addComponent(jLabel9, javax.swing.GroupLayout.DEFAULT_SIZE, 254, Short.MAX_VALUE)))))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(chkobject)
                    .addComponent(rbtnquick)
                    .addComponent(rbtnlong))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(jLabel9))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 298, Short.MAX_VALUE)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(btnselectall)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnremoveall)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnselect)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnremove)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(jScrollPane3))
                .addContainerGap())
        );

        jTabbedPane1.addTab("Object Counter", jPanel4);

        jPanel5.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        chkgender.setText("Gender");

        chkage.setText("Age");

        chkemotion.setText("Emotion");

        jLabel10.setText("Classify the gender");

        jLabel11.setText("Detect the age range 0-2, 4-6, 8-13, 15-20, 25-32, 38-43, 48-53, 60+");

        jLabel12.setText("Detect the 7 classes emotion such as Angry, Disgust, Fear, Happy, Neutral, Sad, Surprise");

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(chkgender, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(chkemotion, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(chkage, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(chkgender)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel10)
                .addGap(43, 43, 43)
                .addComponent(chkage)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel11)
                .addGap(45, 45, 45)
                .addComponent(chkemotion)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel12)
                .addContainerGap(138, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Demographic", jPanel5);

        chkenable.setSelected(true);
        chkenable.setText("Enable");

        btnpreview.setIcon(new javax.swing.ImageIcon(getClass().getResource("/preview.png"))); // NOI18N
        btnpreview.setText("Preview");

        btnsave.setText("Save");
        btnsave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnsaveActionPerformed(evt);
            }
        });

        btnclose.setText("Close");
        btnclose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btncloseActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addComponent(chkenable)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnpreview)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(btnsave)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnclose)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(chkenable)
                    .addComponent(btnpreview)
                    .addComponent(btnsave)
                    .addComponent(btnclose))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1, javax.swing.GroupLayout.Alignment.TRAILING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 417, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 6, Short.MAX_VALUE))
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btnsaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnsaveActionPerformed
        // TODO add your handling code here:
        save( );
    }//GEN-LAST:event_btnsaveActionPerformed

    private void btncloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btncloseActionPerformed
        // TODO add your handling code here:
        dispose();
    }//GEN-LAST:event_btncloseActionPerformed

    private void rbtnremoteItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbtnremoteItemStateChanged
        // TODO add your handling code here:
        lblcameratype.setText("URL:");
    }//GEN-LAST:event_rbtnremoteItemStateChanged

    private void rbtnusbItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbtnusbItemStateChanged
        // TODO add your handling code here:
        lblcameratype.setText("USB Index:");
    }//GEN-LAST:event_rbtnusbItemStateChanged

    private void chkobjectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkobjectActionPerformed
        // TODO add your handling code here:
        if( chkobject.isSelected() ){
            rbtnquick.setEnabled(true);
            rbtnlong.setEnabled(true);
            btnselectall.setEnabled(true);
            btnremoveall.setEnabled(true);
            btnselect.setEnabled(true);
            btnremove.setEnabled(true);
        }else{
            rbtnquick.setEnabled(false);
            rbtnlong.setEnabled(false);
            btnselectall.setEnabled(false);
            btnremoveall.setEnabled(false);
            btnselect.setEnabled(false);
            btnremove.setEnabled(false);
        }
    }//GEN-LAST:event_chkobjectActionPerformed

    private void rbtnquickActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnquickActionPerformed
        // TODO add your handling code here:
        fillObjects( 0 );
    }//GEN-LAST:event_rbtnquickActionPerformed

    private void rbtnlongActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbtnlongActionPerformed
        // TODO add your handling code here:
        fillObjects( 1 );
    }//GEN-LAST:event_rbtnlongActionPerformed

    private void btnselectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnselectActionPerformed
        // TODO add your handling code here:
        if( lstAvailable.getSelectedIndex() >= 0){
            lstSelectedObjects.add( lstAvailableObjects.remove(lstAvailable.getSelectedIndex()));
            selectedObject();
            availableObject();
        }
    }//GEN-LAST:event_btnselectActionPerformed

    private void btnremoveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnremoveActionPerformed
        // TODO add your handling code here:        
        if( lstSelected.getSelectedIndex() >= 0){
            lstAvailableObjects.add( lstSelectedObjects.remove(lstSelected.getSelectedIndex()));
            selectedObject();
            availableObject();
        }
    }//GEN-LAST:event_btnremoveActionPerformed

    private void btnselectallActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnselectallActionPerformed
        // TODO add your handling code here:
        lstSelectedObjects.addAll(lstAvailableObjects);
        lstAvailableObjects.removeAll(lstAvailableObjects);
        selectedObject();
        availableObject();
    }//GEN-LAST:event_btnselectallActionPerformed

    private void btnremoveallActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnremoveallActionPerformed
        // TODO add your handling code here:
        lstAvailableObjects.addAll(lstSelectedObjects);
        lstSelectedObjects.removeAll(lstSelectedObjects);
        selectedObject();
        availableObject();
    }//GEN-LAST:event_btnremoveallActionPerformed

    private void selectedObject(){
                    
        lstSelected.setModel(new javax.swing.AbstractListModel<String>() {
            public int getSize() { return lstSelectedObjects.size(); }
            public String getElementAt(int i) { return lstSelectedObjects.get(i); }
        });
        lstSelected.revalidate();
    }
        
    private void availableObject(){
                    
        lstAvailable.setModel(new javax.swing.AbstractListModel<String>() {
            public int getSize() { return lstAvailableObjects.size(); }
            public String getElementAt(int i) { return lstAvailableObjects.get(i); }
        });
        lstAvailable.revalidate();
    }
    
    private void fillObjects(int mode ){
        lstAvailableObjects.clear();
        if( mode == 0 ){
            for ( String s : Yolov3MobileSSD.classNames){
                if( !lstSelectedObjects.contains(s)){
                    lstAvailableObjects.add(s);
                }
            }
        }else{
            for ( String s : Yolov3DarkNet.classNames){
                if( !lstSelectedObjects.contains(s))
                    lstAvailableObjects.add(s);
            }
        }

        availableObject();
    }
    
    private void save( ){
        try{
            //String[] {name,usbindex,remoteurl,buildinglevel,building,location,position,capturemode,gatenumber,description,status};
            String name = txtname.getText().trim();
            String usbIndex = "-1";
            String url = "";
            if( rbtnusb.isSelected()) usbIndex = txturl.getText().trim();
            else url = txturl.getText().trim();
            int level = cbobuildinglevel.getSelectedIndex();
            String position = cboposition.getSelectedItem().toString();
            String capturemode = cbocapturefor.getSelectedItem().toString();
            String gate = txtgatenumber.getText().trim();
            String description = txtdescription.getText();
            boolean enable = chkenable.isSelected();
            //"alert, counter, countermode, selectedobjects, demograph,"
            boolean alert = chkstrangeralert.isSelected();
            boolean counter = chkobject.isSelected();
            int counterMode = 0;
            if( rbtnlong.isSelected())
                counterMode = 1;
            StringBuilder sb = new StringBuilder();
            for(String s : lstSelectedObjects){
                sb.append(sb.toString().isEmpty() ? s : "," + s );
            }
            boolean demograph = false;
            if( chkgender.isSelected() || chkage.isSelected() || chkemotion.isSelected())
                demograph = true;
            
            String data [] = new String[] {
            name, usbIndex, url,
            level+"","","",position, capturemode, gate,description,enable+"",
            alert+"", counter+"", counterMode+"", sb.toString(), demograph+""};
            
            CenterSQLiteManager sqlManager = new CenterSQLiteManager();
            
            if( id == 0 ){
                id = System.nanoTime();
                int result = sqlManager.saveOrupdateCamera( id, false, data);

                if( result > 0){
                    if( listener != null)
                        listener.onChanged();
                    javax.swing.JOptionPane.showMessageDialog(this, "Saving success");
                    btnsave.setText("Update");
                } else{
                    id = 0;
                    javax.swing.JOptionPane.showMessageDialog(this, "Saving failed");
                }
            }else{
                int result = sqlManager.saveOrupdateCamera( id, true, data);

                if( result > 0){
                    if( listener != null )
                        listener.onChanged();
                    javax.swing.JOptionPane.showMessageDialog(this, "Update success");
                }
                    else
                        javax.swing.JOptionPane.showMessageDialog(this, "Update failed");
            }
            
        }catch(Exception ex){ ex.printStackTrace();}
    }
    
    public void setListener( CameraEntryListener listener ){
        this.listener = listener;
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(CameraRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(CameraRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(CameraRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(CameraRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new CameraRegistration().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnclose;
    private javax.swing.JButton btnpreview;
    private javax.swing.JButton btnremove;
    private javax.swing.JButton btnremoveall;
    private javax.swing.JButton btnsave;
    private javax.swing.JButton btnselect;
    private javax.swing.JButton btnselectall;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.JComboBox<String> cbobuildinglevel;
    private javax.swing.JComboBox<String> cbocapturefor;
    private javax.swing.JComboBox<String> cboposition;
    private javax.swing.JCheckBox chkage;
    private javax.swing.JCheckBox chkemotion;
    private javax.swing.JCheckBox chkenable;
    private javax.swing.JCheckBox chkgender;
    private javax.swing.JCheckBox chkobject;
    private javax.swing.JCheckBox chkstrangeralert;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel lblcameratype;
    private javax.swing.JList<String> lstAvailable;
    private javax.swing.JList<String> lstSelected;
    private javax.swing.JRadioButton rbtnlong;
    private javax.swing.JRadioButton rbtnquick;
    private javax.swing.JRadioButton rbtnremote;
    private javax.swing.JRadioButton rbtnusb;
    private javax.swing.JTextArea txtdescription;
    private javax.swing.JTextField txtgatenumber;
    private javax.swing.JTextField txtname;
    private javax.swing.JTextField txturl;
    // End of variables declaration//GEN-END:variables
}
