/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.communitycenter.ui.v2;



import com.ml.vision.communitycenter.db.CenterSQLiteManager;
import com.ml.vision.communitycenter.db.Visitor;
import com.ml.vision.communitycenter.ui.charts.AreaChart03;
import com.ml.vision.communitycenter.ui.charts.PieChart02;
import com.ml.vision.communitycenter.ui.charts.PieChart03;
import com.ml.vision.communitycenter.ui.charts.PieChart06;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.image.BufferedImage;
import java.util.List;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import org.bytedeco.javacpp.opencv_core;
import org.knowm.xchart.XChartPanel;
import com.ml.vision.autoface.camera.*;
import com.ml.vision.autoface.detection.AgeDetection;
import com.ml.vision.autoface.detection.DetectionManager;
import com.ml.vision.autoface.detection.EmotionDetection;
import com.ml.vision.autoface.detection.FaceDetection;
import com.ml.vision.autoface.detection.GenderDetection;
import com.ml.vision.autoface.detection.objects.ObjectDetectionManager;
import com.ml.vision.autoface.detection.objects.Yolov3DarkNet;
import com.ml.vision.autoface.detection.objects.Yolov3DarkNetNetwork;
import com.ml.vision.autoface.detection.objects.Yolov3MobileSSD;
import com.ml.vision.autoface.detection.objects.Yolov3MobileSSDNetwork;
import com.ml.vision.autoface.listener.FaceListener;
import com.ml.vision.autoface.recognition.RecognitionManager;
import com.ml.vision.autoface.recognition.RecognitionManager.RecognitionManagerLinster;
import com.ml.vision.autoface.util.ScaleFit;
import com.ml.vision.communitycenter.ui.v2.VisitorRegistration.VisitorRegistrationListener;
import java.util.Map;
/**
 *
 * @author apple
 */
public class MainForm extends javax.swing.JFrame {

public static final String VISITING_PURPOSE[] = new String []{ "visit", "shopping", "meeting", "attend" };
private java.util.List<CameraAdvanced> cameras;
private JLabel imageView[];
private VisitorRegistration visitorRegistration = null;
private CenterSQLiteManager sqlManager;
private java.util.HashMap<String,String[]> onVisit = new java.util.LinkedHashMap<>();
private FaceDetection detection;
private Yolov3MobileSSDNetwork yolov3MobileSSDNetwork;
private Yolov3DarkNetNetwork yolov3DarkNetNetwork;

private GenderDetection genderDetector;
private AgeDetection ageDetector;
private EmotionDetection emotionDetector;
private RecognitionManager recognitionManager;
private DetectionManager detectionManager;
private ObjectDetectionManager objectDetectionManager;
private String camData[] = null;

    /**
     * Creates new form MainForm
     */
    public MainForm() {
        initComponents();
                
        sqlManager = new CenterSQLiteManager( );

                /* Create and display the form */
        javax.swing.SwingUtilities.invokeLater(new Runnable( ) {
            @Override
            public void run() {
                try{
                    Thread.sleep( 1000 * 5 );
                }catch(Exception ex){}
                chartsetup();
                detection = new FaceDetection( );
                genderDetector = new GenderDetection( );
                ageDetector = new AgeDetection();
                emotionDetector = new EmotionDetection();
                detectionManager = new DetectionManager( detection );
                objectDetectionManager = new ObjectDetectionManager();
                camerasetup();
            }
        });
         
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                recognitionManager = new RecognitionManager( );
                recognitionManager.setListener(new RecognitionManagerLinster(){
                    @Override
                    public void onRecognize(CameraAdvanced camera, String[] resultData, BufferedImage profileImage) {
                        //_id, name, registered Date, linkId, distance
                        System.out.println("ID="+resultData[0]+", Name="+resultData[1]
                                +", Register date="+resultData[2]+", Camera Id=" + camera.getArrayIndex());
                        if( resultData.length > 3)
                            recordVisitor( Integer.parseInt(resultData[3]), camera, Double.parseDouble(resultData[4]) );
                    }
                });
                recognitionManager.start();
            }
        });
    }

    private void chartsetup(){
        
        JPanel chartPanel1 = new XChartPanel(new AreaChart03( sqlManager ).getChart());
        JPanel chartPanel2 = new XChartPanel(new PieChart06( sqlManager ).getChart());
        JPanel chartPanel3 = new XChartPanel(new PieChart03( sqlManager ).getChart());
        JPanel chartPanel4 = new XChartPanel(new PieChart02().getChart());
        
        JPanel chartPanel = new JPanel();
        chartPanel.add(chartPanel1);
        chartPanel.add(chartPanel2);
        chartPanel.add(chartPanel3);
        chartPanel.add(chartPanel4);
        
        jTabbedPane1.add(chartPanel,"Dashboard",0 );
        jTabbedPane1.setSelectedIndex(0);
        jTabbedPane1.validate( );
    }
    
    private void camerasetup(){

        cameras = new java.util.ArrayList<>();
        
        java.util.List<String[]> data = sqlManager.getCameraData( 0, null );
        for( String[] info : data ){
            if( !info[8].equals("Registration") )
                addCamera( info );
            else
                camData = info;
        }
        
        System.out.println( data.size()+"," + cameras.size() );
        
        int gridRow = cameras.size() / 3 + (cameras.size() % 3 >0 ? 1 : 0) ;
        JPanel chartPanel = new JPanel();
        chartPanel.setLayout( new GridLayout( gridRow, 3) );
        int v=ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS;
        int h=ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED; 
        JScrollPane jsp=new JScrollPane( chartPanel,v,h);
        jTabbedPane1.add( jsp,"Live Cam", 1 );
        imageView = new JLabel[cameras.size()];
        for(int i=0; i< imageView.length; i++) {
            
            imageView[i] = new JLabel();
            imageView[i].setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
            imageView[i].setForeground(Color.GREEN);
            imageView[i].setBorder(javax.swing.BorderFactory.createEtchedBorder());
            imageView[i].setText( cameras.get(i).getCamName() );
            chartPanel.add( imageView[i] );
        }
        chartPanel.validate();
                
        CameraManager cammgr = new CameraManager( cameras, detectionManager, objectDetectionManager );
        cammgr.setListener(new FaceListener() {
            @Override
            public void onDetectedFaces( List<opencv_core.Mat> faces, CameraAdvanced camera, int index ) {
                if( faces != null && !faces.isEmpty() ){
                    faces.forEach((face) -> {
                        recognitionManager.recognize( new Object[]{ face.clone(), camera } );
                    });
                }
            }

            @Override
            public void onCapture(CameraAdvanced camera, opencv_core.Mat image, int index) {
                
            }

            @Override
            public void onCapture(CameraAdvanced camera, BufferedImage image, int index) {
                                
                BufferedImage scaleImage = ScaleFit.scaleFit( image,200 );
                imageView[index].setIcon( new ImageIcon( scaleImage ) );
                imageView[index].revalidate();
                imageView[index].repaint();
            }

            @Override
            public void onDemographic(List<String[]> demographic, Map<String, Integer> increasedCount, CameraAdvanced camera) {
//                if( increasedCount != null )
//                    System.out.println("New Object count="+ increasedCount.size() );
//                if( demographic != null )
//                    System.out.println(", Demograph=" + demographic.size() );
                objectRecord( demographic, increasedCount, camera );
            }

            @Override
            public void onFailed( CameraAdvanced camera, int index ) {
                //System.out.println( "Camera failed, index=" + index );
            }

        });
        cammgr.start( );
    }
        
    private CameraAdvanced addCamera( String[] data ){
        CameraAdvanced cam = null;
        if( data == null ) return cam;
        if( data[12].trim().equalsIgnoreCase("false")) return cam;
        
        try{
            cam = new CameraAdvanced( data );
            if( Integer.parseInt(data[2]) == 0 )
                cameras.add(0, cam);
            else
                cameras.add(cam);
            
            cam.setArrayIndex( cameras.indexOf(cam) );
            //cam.setDetection( detection );
            
            if( Boolean.parseBoolean(data[14]) ){ // obj counter enable/disable
                int mode = Integer.parseInt(data[15]);// 0 for Yolo mobile SSD, 1 for Darknet
                java.util.List<String> lstClassName = new java.util.ArrayList<>();
                if( data[16]!= null && !data[16].isEmpty() ){// selected obj to detect
                    String selectedObj [] = data[16].split(",");
                    for ( String s : selectedObj)
                        lstClassName.add(s);
                }
                
                if(!lstClassName.isEmpty()){
                    if( mode == 0){
                        if( Boolean.parseBoolean(data[17])){
                            if( yolov3MobileSSDNetwork == null )
                                yolov3MobileSSDNetwork = new Yolov3MobileSSDNetwork( );
                            
                            Yolov3MobileSSD yolo = new Yolov3MobileSSD( yolov3MobileSSDNetwork.getNet(), lstClassName, true, true,
                            detection, genderDetector, ageDetector, emotionDetector );
                            yolo.setRectangleObject( false );
                            cam.setObjectDetector( yolo );
                            System.out.println("MobileSSD Demographic enable");
                        }else{
                            Yolov3MobileSSD yolo = new Yolov3MobileSSD( yolov3MobileSSDNetwork.getNet(), lstClassName, true );
                            yolo.setRectangleObject(false);
                            cam.setObjectDetector( yolo );
                            System.out.println("MobileSSD Demographic disable");
                        }
                    }else{
                        if( yolov3DarkNetNetwork == null )
                            yolov3DarkNetNetwork = new Yolov3DarkNetNetwork();
                        
                        if( Boolean.parseBoolean(data[17])){
                            Yolov3DarkNet yolo = new Yolov3DarkNet( yolov3DarkNetNetwork.getNet(), lstClassName, true, true,
                            detection, genderDetector, ageDetector, emotionDetector );
                            yolo.setRectangleObject(false);
                            cam.setObjectDetector( yolo );
                            System.out.println("DarkNet Demographic enable");
                        }else{
                            Yolov3DarkNet yolo = new Yolov3DarkNet( yolov3DarkNetNetwork.getNet(), lstClassName, true );
                            yolo.setRectangleObject(false);
                            cam.setObjectDetector( yolo );
                            System.out.println("DarkNet Demographic disable");
                        }
                        
                    }
                }
            }else{
                System.out.println("Counter disable");
            }
            
            
//            lstClassName.add( Yolov3MobileSSD.MOBILE_OBJECT_PERSON );
//            lstClassName.add( Yolov3MobileSSD.MOBILE_OBJECT_BICYCLE );
//            lstClassName.add( Yolov3MobileSSD.MOBILE_OBJECT_BUS );
//            lstClassName.add( Yolov3MobileSSD.MOBILE_OBJECT_CAR );
//            lstClassName.add( Yolov3MobileSSD.MOBILE_OBJECT_MOTORBIKE );
//            lstClassName.add( Yolov3MobileSSD.MOBILE_OBJECT_TRAIN );
//            Yolov3MobileSSD yolo = new Yolov3MobileSSD( yolov3MobileSSDNetwork.getNet(), lstClassName, true, true,
//            detection, genderDetector, ageDetector, emotionDetector );
//            cam.setObjectDetector( yolo );
            
                        
//            java.util.List<String> lstClassName = new java.util.ArrayList<>();
//            lstClassName.add( Yolov3DarkNet.DARKNET_OBJECT_PERSON );
//            lstClassName.add( Yolov3DarkNet.DARKNET_OBJECT_BICYCLE );
//            lstClassName.add( Yolov3DarkNet.DARKNET_OBJECT_BUS );
//            lstClassName.add( Yolov3DarkNet.DARKNET_OBJECT_CAR );
//            lstClassName.add( Yolov3DarkNet.DARKNET_OBJECT_CUP );
//            lstClassName.add( Yolov3DarkNet.DARKNET_OBJECT_FORK );
//            Yolov3DarkNet yolo = new Yolov3DarkNet( yolov3DarkNetNetwork.getNet(), lstClassName, true, true,
//            detection, genderDetector, ageDetector, emotionDetector );
//            cam.setObjectDetector( yolo );
            
            
        }catch(Exception ex){ex.printStackTrace();}
        
        return cam;
    }
    
    private String[ ] recordVisitor( int sid, CameraAdvanced camera, double acceptanceLevel ){
        
        //int labelId = sid;
        String info[] = null;
        if( sid < 1 ) return info;
        
        String vData[] = onVisit.get( sid + "-" + camera.getCamId() );
        
//        System.out.println(labelId);
        
        if( vData == null ){
           java.util.List<Visitor> data = sqlManager.getVisitorData( sid, "");
           if( data != null && !data.isEmpty()){
               String personInfo [] = data.get(0).getInformatin();
               // visitor id, name, camera id, entry time, last visit time, confidence
               info = new String[]{ sid + "", personInfo[1], camera.getCamId() + "", System.currentTimeMillis() + "", System.currentTimeMillis() + "", acceptanceLevel + "" };
               onVisit.put(sid + "-" + camera.getCamId(), info );
               
               if( !camera.getCaptureMode().trim().toLowerCase().equals("registration")){//registration
                    int recordResut = record(  info );
                    System.out.println("New Visit recording result="+  recordResut+", Visitor Name=" + 
                            info[1]+", Cam name=" + camera.getCamId() +", Confidence=" + acceptanceLevel );
               }
           }
        }else{
            info = vData;
//            System.out.println( "Dif time:" +  ( System.currentTimeMillis() - Long.parseLong( info[4] )) );
            if( System.currentTimeMillis() - Long.parseLong( info[4] ) > VisitorRegistration.SINGLE_RECORD_THRESHOLD && 
                    !camera.getCaptureMode().trim().toLowerCase().equals("registration")){//registration
                
                info[4] = System.currentTimeMillis() + "";
                info[5]= acceptanceLevel + "";
                int recordResut = record(  info );
               System.out.println("Re Visit recording result="+  recordResut+", Visitor Name=" + 
                       info[1]+", Cam name=" + camera.getCamId() +", Confidence=" + acceptanceLevel );
               
            }
        }
        System.gc();
        return info;
    }
    
    int totalWriteCount = 0;
    private int record( String info[] ){
        int result = -1;
        String[] lastVisit =  sqlManager.getLastVisitingRecord( info[0], info[2] );
        
        if( lastVisit == null ){
            result = sqlManager.saveOrupdateRecording( System.nanoTime(), false, new String[]{ info[0], info[2], VISITING_PURPOSE[0], info[5] });
        }else{
            int countNum = Integer.parseInt(lastVisit[1]) + 1;
            result = sqlManager.saveOrupdateRecording( Long.parseLong( lastVisit[0] ), true, new String[]{ countNum + "", info[5] });
            System.out.println( "Visit count = "+ countNum );
        }
        totalWriteCount += result;
        System.out.println("Total write count=" + totalWriteCount);
        return result;
    }
    
    private void objectRecord( List<String[]> demographic, Map<String, Integer> increasedCount, CameraAdvanced camera ){
        int result = -1;
        try{
            for( Map.Entry<String, Integer> entry : increasedCount.entrySet()){
                //( String cID, String objectname, String agegroup, String gendergroup, String emogroup )
                String resultData[] = sqlManager.getLastCameraRecord( camera.getCamId() + "", entry.getKey(), "unknown" , "unknown", "unknown");
                if( resultData == null ){
                    //camerarecord( cameraid, lastknown, objectname, objcount, agegroup, gendergroup, emogroup, counton, _id)
                    String saveData[] = new String[]{camera.getCamId()+"", entry.getKey(), entry.getValue()+"", "unknown" , "unknown", "unknown"};
                    result = sqlManager.saveOrupdateCameraRecording( System.nanoTime(), false, saveData );
                }else{
                    int countNum = Integer.parseInt(resultData[1]) + entry.getValue();
                    result = sqlManager.saveOrupdateCameraRecording( Long.parseLong( resultData[0] ), true, new String[]{ countNum + "" });
                }
            }
        }catch(Exception ex){ex.printStackTrace();}
        
                
        try{
            for( String[] entry : demographic ){
                //( String cID, String objectname, String agegroup, String gendergroup, String emogroup )
                String resultData[] = sqlManager.getLastCameraRecord( camera.getCamId()+"", "person", entry[0] , entry[1], entry[2] );
                if( resultData == null ){
                    //camerarecord( cameraid, lastknown, objectname, objcount, agegroup, gendergroup, emogroup, counton, _id)
                    String saveData[] = new String[]{camera.getCamId()+"", "person", "1", entry[0] , entry[1], entry[2]};
                    result = sqlManager.saveOrupdateCameraRecording( System.nanoTime(), false, saveData );
                }else{
                    int countNum = Integer.parseInt(resultData[1]) + 1;
                    result = sqlManager.saveOrupdateCameraRecording( Long.parseLong( resultData[0] ), true, new String[]{ countNum + "" });
                }
            }
        }catch(Exception ex){ex.printStackTrace();}
        System.gc();
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jToolBar2 = new javax.swing.JToolBar();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        btnregister = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        btndriver = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        jButton1 = new javax.swing.JButton();
        jSeparator7 = new javax.swing.JToolBar.Separator();
        btnluckydraw = new javax.swing.JButton();
        jSeparator8 = new javax.swing.JToolBar.Separator();
        jButton2 = new javax.swing.JButton();
        jSeparator9 = new javax.swing.JToolBar.Separator();
        jButton3 = new javax.swing.JButton();
        jSeparator10 = new javax.swing.JToolBar.Separator();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenu3 = new javax.swing.JMenu();
        jMenuItem5 = new javax.swing.JMenuItem();
        jMenuItem6 = new javax.swing.JMenuItem();
        jSeparator5 = new javax.swing.JPopupMenu.Separator();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenu5 = new javax.swing.JMenu();
        jMenuItem11 = new javax.swing.JMenuItem();
        jMenuItem13 = new javax.swing.JMenuItem();
        jSeparator6 = new javax.swing.JPopupMenu.Separator();
        jMenuItem12 = new javax.swing.JMenuItem();
        jMenu6 = new javax.swing.JMenu();
        jMenuItem14 = new javax.swing.JMenuItem();
        jMenuItem15 = new javax.swing.JMenuItem();
        jMenu7 = new javax.swing.JMenu();
        jMenuItem16 = new javax.swing.JMenuItem();
        jMenu4 = new javax.swing.JMenu();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem18 = new javax.swing.JMenuItem();
        jMenuItem9 = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JPopupMenu.Separator();
        jMenuItem10 = new javax.swing.JMenuItem();
        jMenu8 = new javax.swing.JMenu();
        jMenuItem17 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Pyin Oo Lwin Centre");
        setExtendedState(java.awt.Frame.MAXIMIZED_BOTH);

        jToolBar2.setFloatable(false);
        jToolBar2.setRollover(true);
        jToolBar2.add(jSeparator1);

        btnregister.setIcon(new javax.swing.ImageIcon(getClass().getResource("/user.png"))); // NOI18N
        btnregister.setToolTipText("Register new visitor");
        btnregister.setFocusable(false);
        btnregister.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnregister.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnregister.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnregisterActionPerformed(evt);
            }
        });
        jToolBar2.add(btnregister);
        jToolBar2.add(jSeparator2);

        btndriver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/driver.png"))); // NOI18N
        btndriver.setToolTipText("Register new driver");
        btndriver.setFocusable(false);
        btndriver.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btndriver.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(btndriver);
        jToolBar2.add(jSeparator3);

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/delivery.png"))); // NOI18N
        jButton1.setToolTipText("Received visitors from driver");
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(jButton1);
        jToolBar2.add(jSeparator7);

        btnluckydraw.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gift.png"))); // NOI18N
        btnluckydraw.setToolTipText("Lucky draw");
        btnluckydraw.setFocusable(false);
        btnluckydraw.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnluckydraw.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(btnluckydraw);
        jToolBar2.add(jSeparator8);

        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/add_folder_yellow.png"))); // NOI18N
        jButton2.setToolTipText("add meeting minutes");
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(jButton2);
        jToolBar2.add(jSeparator9);

        jButton3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/diagram.png"))); // NOI18N
        jButton3.setToolTipText("Reportings");
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(jButton3);
        jToolBar2.add(jSeparator10);

        jMenu1.setText("File");

        jMenuItem2.setText("Settings");
        jMenu1.add(jMenuItem2);

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem1.setMnemonic('x');
        jMenuItem1.setText("Exit");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Visitor");

        jMenuItem3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/user.png"))); // NOI18N
        jMenuItem3.setText("Register");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem3);

        jMenuItem4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/writing.png"))); // NOI18N
        jMenuItem4.setText("Edit");
        jMenu2.add(jMenuItem4);

        jMenuBar1.add(jMenu2);

        jMenu3.setText("Driver");

        jMenuItem5.setIcon(new javax.swing.ImageIcon(getClass().getResource("/driver.png"))); // NOI18N
        jMenuItem5.setText("Register");
        jMenu3.add(jMenuItem5);

        jMenuItem6.setIcon(new javax.swing.ImageIcon(getClass().getResource("/writing.png"))); // NOI18N
        jMenuItem6.setText("Edit");
        jMenu3.add(jMenuItem6);
        jMenu3.add(jSeparator5);

        jMenuItem7.setIcon(new javax.swing.ImageIcon(getClass().getResource("/delivery.png"))); // NOI18N
        jMenuItem7.setText("Visitor Receive");
        jMenu3.add(jMenuItem7);

        jMenuBar1.add(jMenu3);

        jMenu5.setText("Lucky Draw");

        jMenuItem11.setIcon(new javax.swing.ImageIcon(getClass().getResource("/add.png"))); // NOI18N
        jMenuItem11.setText("New");
        jMenu5.add(jMenuItem11);

        jMenuItem13.setIcon(new javax.swing.ImageIcon(getClass().getResource("/list.png"))); // NOI18N
        jMenuItem13.setText("List");
        jMenu5.add(jMenuItem13);
        jMenu5.add(jSeparator6);

        jMenuItem12.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gift.png"))); // NOI18N
        jMenuItem12.setText("Draw");
        jMenu5.add(jMenuItem12);

        jMenuBar1.add(jMenu5);

        jMenu6.setText("Meeting");

        jMenuItem14.setIcon(new javax.swing.ImageIcon(getClass().getResource("/add_folder_yellow.png"))); // NOI18N
        jMenuItem14.setText("Add minutes");
        jMenu6.add(jMenuItem14);

        jMenuItem15.setIcon(new javax.swing.ImageIcon(getClass().getResource("/search.png"))); // NOI18N
        jMenuItem15.setText("Search");
        jMenu6.add(jMenuItem15);

        jMenuBar1.add(jMenu6);

        jMenu7.setText("Reporting");

        jMenuItem16.setIcon(new javax.swing.ImageIcon(getClass().getResource("/diagram.png"))); // NOI18N
        jMenuItem16.setText("Reports");
        jMenu7.add(jMenuItem16);

        jMenuBar1.add(jMenu7);

        jMenu4.setText("Camera");

        jMenuItem8.setIcon(new javax.swing.ImageIcon(getClass().getResource("/add.png"))); // NOI18N
        jMenuItem8.setText("Add camera");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem8);

        jMenuItem18.setIcon(new javax.swing.ImageIcon(getClass().getResource("/writing.png"))); // NOI18N
        jMenuItem18.setText("Edit Camera");
        jMenu4.add(jMenuItem18);

        jMenuItem9.setIcon(new javax.swing.ImageIcon(getClass().getResource("/list.png"))); // NOI18N
        jMenuItem9.setText("Camera List");
        jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem9ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem9);
        jMenu4.add(jSeparator4);

        jMenuItem10.setText("Camera Settings");
        jMenu4.add(jMenuItem10);

        jMenuBar1.add(jMenu4);

        jMenu8.setText("Help");

        jMenuItem17.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
        jMenuItem17.setIcon(new javax.swing.ImageIcon(getClass().getResource("/info.png"))); // NOI18N
        jMenuItem17.setMnemonic('h');
        jMenuItem17.setText("Help Contents");
        jMenu8.add(jMenuItem17);

        jMenuBar1.add(jMenu8);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
            .addComponent(jToolBar2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jToolBar2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1))
        );

        jTabbedPane1.getAccessibleContext().setAccessibleName("Dashboard");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void btnregisterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnregisterActionPerformed
        // TODO add your handling code here:
                /* Create and display the form */
        try{
            visitorRegistration = new VisitorRegistration( camData );
            visitorRegistration.setListener(new VisitorRegistrationListener(){
                @Override
                public void onSave(String name, opencv_core.Mat imgbgr, String profilePath, String photoPath, int linkId) {
                    int result = recognitionManager.save( name, imgbgr, profilePath, photoPath, linkId );
                    if( result > 0 ){
                        java.io.File ff = new java.io.File( profilePath );
                        ff.delete();
                    }
                }
            });
            visitorRegistration.setVisible( true );
        }catch(Exception ex){ex.printStackTrace();}
        
        
    }//GEN-LAST:event_btnregisterActionPerformed

    private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
        // TODO add your handling code here:
        new CameraRegistration().setVisible(true);
    }//GEN-LAST:event_jMenuItem8ActionPerformed

    private void jMenuItem9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem9ActionPerformed
        // TODO add your handling code here:
        new CameraList().setVisible(true);
    }//GEN-LAST:event_jMenuItem9ActionPerformed

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        // TODO add your handling code here:
                /* Create and display the form */
        btnregister.doClick();
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainForm().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btndriver;
    private javax.swing.JButton btnluckydraw;
    private javax.swing.JButton btnregister;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenu jMenu3;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenu jMenu5;
    private javax.swing.JMenu jMenu6;
    private javax.swing.JMenu jMenu7;
    private javax.swing.JMenu jMenu8;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem10;
    private javax.swing.JMenuItem jMenuItem11;
    private javax.swing.JMenuItem jMenuItem12;
    private javax.swing.JMenuItem jMenuItem13;
    private javax.swing.JMenuItem jMenuItem14;
    private javax.swing.JMenuItem jMenuItem15;
    private javax.swing.JMenuItem jMenuItem16;
    private javax.swing.JMenuItem jMenuItem17;
    private javax.swing.JMenuItem jMenuItem18;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JMenuItem jMenuItem6;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator10;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JPopupMenu.Separator jSeparator4;
    private javax.swing.JPopupMenu.Separator jSeparator5;
    private javax.swing.JPopupMenu.Separator jSeparator6;
    private javax.swing.JToolBar.Separator jSeparator7;
    private javax.swing.JToolBar.Separator jSeparator8;
    private javax.swing.JToolBar.Separator jSeparator9;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JToolBar jToolBar2;
    // End of variables declaration//GEN-END:variables
}
