/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ml.vision.demo;

import com.ml.vision.autoface.camera.CameraAdvanced;
import com.ml.vision.autoface.client.remote.Recognizer;
import com.ml.vision.autoface.client.remote.Register;
import com.ml.vision.autoface.detection.AgeDetection;
import com.ml.vision.autoface.detection.EmotionDetection;
import com.ml.vision.autoface.detection.FaceDetection;
import com.ml.vision.autoface.detection.GenderDetection;
import com.ml.vision.autoface.detection.objects.Yolov3MobileSSD;
import com.ml.vision.autoface.detection.objects.Yolov3MobileSSDNetwork;
import com.ml.vision.autoface.listener.CameraListener;
import com.ml.vision.autoface.recognition.Recognition;
import com.ml.vision.autoface.util.Constants;
import com.ml.vision.autoface.util.ScaleFit;
import java.awt.image.BufferedImage;
import java.io.File;
import java.util.List;
import java.util.Map;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import org.bytedeco.javacpp.opencv_core;
import org.bytedeco.javacv.Java2DFrameConverter;
import org.bytedeco.javacv.OpenCVFrameConverter;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

/**
 *
 * @author apple
 */
public class TestObjectRecognition extends javax.swing.JFrame {

    private CameraAdvanced camera;
    private FaceDetection detection;
    private OpenCVFrameConverter.ToIplImage converter;
    private opencv_core.Mat matPreview;
    private List<opencv_core.Mat> faces;
    
    
    /**
     * Creates new form TestRecognition
     */
    public TestObjectRecognition() {
        initComponents();
                
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                try{
                    Thread.sleep( 1000 * 5 );
                }catch(Exception ex){}
                
                converter = new OpenCVFrameConverter.ToIplImage( );
                detection = new FaceDetection( );
                java.util.List<String> lstClassName = new java.util.ArrayList<>();
                Yolov3MobileSSD yolo = new Yolov3MobileSSD( new Yolov3MobileSSDNetwork( ).getNet(), lstClassName, false, false,
                            detection, null, null, null );
                yolo.setRectangleObject( false );
//                objectDetector.detect( camera.getLastCapture() );
//                        listener.onDemographic( objectDetector.getDemographic(), objectDetector.getIncreasedCount(), camera, (long) o[1]);
                
                registerCamera(  );
            }
        });
        
    }
    
    private void registerCamera( ){
        
        try{
            camera = new CameraAdvanced( 0 );
            camera.setDetection( detection );
            camera.setFramePerSecond( 20 );
            camera.setSortFaceBySize(true);
            camera.setListener(new CameraListener(){
                @Override
                public void onCaptureByFPS(CameraAdvanced camera) {
                    
                }

                @Override
                public void onCapture(CameraAdvanced camera) {
                    if( camera.getLastCapture() != null ){
                        matPreview = camera.getLastCapture();
                        BufferedImage image = new Java2DFrameConverter( ).convert( converter.convert( matPreview ) );
                        lblpreview.setIcon( new ImageIcon( ScaleFit.scaleFit( image,300 ) ) );
                        lblpreview.setText("");
                        lblpreview.revalidate( );
                        lblpreview.repaint( );
                    }
                }

                @Override
                public void onCapture( List<opencv_core.Mat> faces, CameraAdvanced camera ) {
                }

                @Override
                public void onDemographic(List<String[]> demographic, Map<String, Integer> increasedCount, CameraAdvanced camera) { }

                @Override
                public void onFailed(CameraAdvanced camera) { }
            });
            camera.start();
        }catch(Exception ex){}
    }
  
    private void initializeRecognizer(){
    }
    
    private void register( ){
        
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        lblpreview = new javax.swing.JLabel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        txtname = new javax.swing.JTextField();
        btnregister = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        lblresult = new javax.swing.JLabel();
        rbtndemographic = new javax.swing.JCheckBox();
        rbtnrecognize = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        lblpreview.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblpreview.setIcon(new javax.swing.ImageIcon(getClass().getResource("/camera.png"))); // NOI18N
        lblpreview.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        btnregister.setText("Register");
        btnregister.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnregisterActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(txtname, javax.swing.GroupLayout.DEFAULT_SIZE, 508, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnregister)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtname, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnregister))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Register", jPanel2);

        lblresult.setText("result");

        rbtndemographic.setText("Demographic");

        rbtnrecognize.setText("Recognize");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblresult, javax.swing.GroupLayout.DEFAULT_SIZE, 385, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbtnrecognize)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbtndemographic)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rbtndemographic)
                    .addComponent(rbtnrecognize)
                    .addComponent(lblresult))
                .addContainerGap(10, Short.MAX_VALUE))
        );

        jTabbedPane1.addTab("Recognition", jPanel3);

        jTabbedPane1.setSelectedIndex(1);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lblpreview, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(lblpreview, javax.swing.GroupLayout.DEFAULT_SIZE, 365, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnregisterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnregisterActionPerformed
        // TODO add your handling code here:
        register();
    }//GEN-LAST:event_btnregisterActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(TestObjectRecognition.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(TestObjectRecognition.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(TestObjectRecognition.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(TestObjectRecognition.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new TestObjectRecognition().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnregister;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel lblpreview;
    private javax.swing.JLabel lblresult;
    private javax.swing.JCheckBox rbtndemographic;
    private javax.swing.JCheckBox rbtnrecognize;
    private javax.swing.JTextField txtname;
    // End of variables declaration//GEN-END:variables
}