package com.ml.vision.ftp;



import com.enterprisedt.net.ftp.FTPClient;
import com.ml.vision.communitycenter.ui.v2.*;
import com.ml.vision.communitycenter.db.CenterSQLiteManager;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.image.BufferedImage;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import org.bytedeco.javacpp.opencv_core;
import com.ml.vision.autoface.util.ScaleFit;
import com.ml.vision.ftp.camera.CameraBasic;
import com.ml.vision.ftp.camera.CameraManagerBasic;
import com.ml.vision.ftp.listener.CameraManagerBasicListener;



public class MainForm extends javax.swing.JFrame {

private java.util.List<CameraBasic> cameras;
private JLabel imageView[];
private CenterSQLiteManager sqlManager;
private String camData[] = null;
FTPClient ftp = null;



    public MainForm() {
        initComponents();
                
        sqlManager = new CenterSQLiteManager( );

                /* Create and display the form */
        javax.swing.SwingUtilities.invokeLater(new Runnable( ) {
            @Override
            public void run() {
                try{
                    Thread.sleep( 1000 * 5 );
                    camerasetup();
                }catch(Exception ex){}
            }
        });
         
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                
            }
        });
    }

    private void camerasetup(){

        cameras = new java.util.ArrayList<>();
        
        java.util.List<String[]> data = sqlManager.getCameraData( 0, null );
        for( String[] info : data ){
            if( !info[8].equals("Registration") )
                addCamera( info );
            else
                camData = info;
        }
        
        System.out.println( data.size()+"," + cameras.size() );
        
        int gridRow = cameras.size() / 3 + (cameras.size() % 3 >0 ? 1 : 0) ;
        JPanel chartPanel = new JPanel();
        chartPanel.setLayout( new GridLayout( gridRow, 3) );
        int v=ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS;
        int h=ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED; 
        JScrollPane jsp=new JScrollPane( chartPanel,v,h);
        jTabbedPane1.add( jsp,"Live Cam", 0 );
        jTabbedPane1.setSelectedIndex(0);
        jTabbedPane1.validate( );
        
        
        imageView = new JLabel[cameras.size()];
        for(int i=0; i< imageView.length; i++) {
            
            imageView[i] = new JLabel();
            imageView[i].setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
            imageView[i].setForeground(Color.GREEN);
            imageView[i].setBorder(javax.swing.BorderFactory.createEtchedBorder());
            imageView[i].setText( cameras.get(i).getCamName() );
            chartPanel.add( imageView[i] );
        }
        chartPanel.validate();
                
        CameraManagerBasic cammgr = new CameraManagerBasic( cameras);
        cammgr.setListener(new CameraManagerBasicListener() {

            @Override
            public void onCapture(CameraBasic camera, opencv_core.Mat image, int index) {
//                https://enterprisedt.com/products/edtftpjssl/examples/howto/upload_download_and_delete_a_file/UploadDownloadFiles.java.html
//                try{
//                    ftp = new FTPClient();
//                    ftp.setRemoteHost("192.168.1.88");
//                    ftp.setRemotePort(3131);
//                    ftp.connect();
//                    ftp.login("username", "password");
//                    ftp.put(localPath, remoteFile);
//                    ftp.quit();
//                    
//                }catch(Exception e){e.printStackTrace();}
                
            }

            @Override
            public void onCapture(CameraBasic camera, BufferedImage image, int index) {
                                
                BufferedImage scaleImage = ScaleFit.scaleFit( image,200 );
                imageView[index].setIcon( new ImageIcon( scaleImage ) );
                imageView[index].revalidate();
                imageView[index].repaint();
            }

            @Override
            public void onFailed( CameraBasic camera, int index ) {
                //System.out.println( "Camera failed, index=" + index );
            }

        });
        cammgr.start( );
    }
        
    private CameraBasic addCamera( String[] data ){
        CameraBasic cam = null;
        if( data == null ) return cam;
        if( data[12].trim().equalsIgnoreCase("false")) return cam;
        
        try{
            cam = new CameraBasic( data );
            if( Integer.parseInt(data[2]) == 0 )
                cameras.add(0, cam);
            else
                cameras.add(cam);
            
            cam.setArrayIndex( cameras.indexOf(cam) );
            
        }catch(Exception ex){ex.printStackTrace();}
        
        return cam;
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        jToolBar2 = new javax.swing.JToolBar();
        jSeparator1 = new javax.swing.JToolBar.Separator();
        btnregister = new javax.swing.JButton();
        jSeparator2 = new javax.swing.JToolBar.Separator();
        btndriver = new javax.swing.JButton();
        jSeparator3 = new javax.swing.JToolBar.Separator();
        jButton1 = new javax.swing.JButton();
        jSeparator7 = new javax.swing.JToolBar.Separator();
        btnluckydraw = new javax.swing.JButton();
        jSeparator8 = new javax.swing.JToolBar.Separator();
        jButton2 = new javax.swing.JButton();
        jSeparator9 = new javax.swing.JToolBar.Separator();
        jButton3 = new javax.swing.JButton();
        jSeparator10 = new javax.swing.JToolBar.Separator();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenu4 = new javax.swing.JMenu();
        jMenuItem8 = new javax.swing.JMenuItem();
        jMenuItem18 = new javax.swing.JMenuItem();
        jMenuItem9 = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JPopupMenu.Separator();
        jMenuItem10 = new javax.swing.JMenuItem();
        jMenu8 = new javax.swing.JMenu();
        jMenuItem17 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("FTP Connector");
        setExtendedState(java.awt.Frame.MAXIMIZED_BOTH);

        jToolBar2.setFloatable(false);
        jToolBar2.setRollover(true);
        jToolBar2.add(jSeparator1);

        btnregister.setIcon(new javax.swing.ImageIcon(getClass().getResource("/user.png"))); // NOI18N
        btnregister.setToolTipText("Register new visitor");
        btnregister.setFocusable(false);
        btnregister.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnregister.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btnregister.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnregisterActionPerformed(evt);
            }
        });
        jToolBar2.add(btnregister);
        jToolBar2.add(jSeparator2);

        btndriver.setIcon(new javax.swing.ImageIcon(getClass().getResource("/driver.png"))); // NOI18N
        btndriver.setToolTipText("Register new driver");
        btndriver.setFocusable(false);
        btndriver.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btndriver.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(btndriver);
        jToolBar2.add(jSeparator3);

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/delivery.png"))); // NOI18N
        jButton1.setToolTipText("Received visitors from driver");
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(jButton1);
        jToolBar2.add(jSeparator7);

        btnluckydraw.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gift.png"))); // NOI18N
        btnluckydraw.setToolTipText("Lucky draw");
        btnluckydraw.setFocusable(false);
        btnluckydraw.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnluckydraw.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(btnluckydraw);
        jToolBar2.add(jSeparator8);

        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/add_folder_yellow.png"))); // NOI18N
        jButton2.setToolTipText("add meeting minutes");
        jButton2.setFocusable(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(jButton2);
        jToolBar2.add(jSeparator9);

        jButton3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/diagram.png"))); // NOI18N
        jButton3.setToolTipText("Reportings");
        jButton3.setFocusable(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar2.add(jButton3);
        jToolBar2.add(jSeparator10);

        jMenu1.setText("File");

        jMenuItem2.setText("Settings");
        jMenu1.add(jMenuItem2);

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem1.setMnemonic('x');
        jMenuItem1.setText("Exit");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        jMenu4.setText("Camera");

        jMenuItem8.setIcon(new javax.swing.ImageIcon(getClass().getResource("/add.png"))); // NOI18N
        jMenuItem8.setText("Add camera");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem8);

        jMenuItem18.setIcon(new javax.swing.ImageIcon(getClass().getResource("/writing.png"))); // NOI18N
        jMenuItem18.setText("Edit Camera");
        jMenu4.add(jMenuItem18);

        jMenuItem9.setIcon(new javax.swing.ImageIcon(getClass().getResource("/list.png"))); // NOI18N
        jMenuItem9.setText("Camera List");
        jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem9ActionPerformed(evt);
            }
        });
        jMenu4.add(jMenuItem9);
        jMenu4.add(jSeparator4);

        jMenuItem10.setText("Camera Settings");
        jMenu4.add(jMenuItem10);

        jMenuBar1.add(jMenu4);

        jMenu8.setText("Help");

        jMenuItem17.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F1, 0));
        jMenuItem17.setIcon(new javax.swing.ImageIcon(getClass().getResource("/info.png"))); // NOI18N
        jMenuItem17.setMnemonic('h');
        jMenuItem17.setText("Help Contents");
        jMenu8.add(jMenuItem17);

        jMenuBar1.add(jMenu8);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTabbedPane1)
            .addComponent(jToolBar2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jToolBar2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTabbedPane1))
        );

        jTabbedPane1.getAccessibleContext().setAccessibleName("Dashboard");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void btnregisterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnregisterActionPerformed
        // TODO add your handling code here:
                /* Create and display the form */
    }//GEN-LAST:event_btnregisterActionPerformed

    private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
        // TODO add your handling code here:
        new CameraRegistration().setVisible(true);
    }//GEN-LAST:event_jMenuItem8ActionPerformed

    private void jMenuItem9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem9ActionPerformed
        // TODO add your handling code here:
        new CameraList().setVisible(true);
    }//GEN-LAST:event_jMenuItem9ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainForm.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainForm().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btndriver;
    private javax.swing.JButton btnluckydraw;
    private javax.swing.JButton btnregister;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu4;
    private javax.swing.JMenu jMenu8;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem10;
    private javax.swing.JMenuItem jMenuItem17;
    private javax.swing.JMenuItem jMenuItem18;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem8;
    private javax.swing.JMenuItem jMenuItem9;
    private javax.swing.JToolBar.Separator jSeparator1;
    private javax.swing.JToolBar.Separator jSeparator10;
    private javax.swing.JToolBar.Separator jSeparator2;
    private javax.swing.JToolBar.Separator jSeparator3;
    private javax.swing.JPopupMenu.Separator jSeparator4;
    private javax.swing.JToolBar.Separator jSeparator7;
    private javax.swing.JToolBar.Separator jSeparator8;
    private javax.swing.JToolBar.Separator jSeparator9;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JToolBar jToolBar2;
    // End of variables declaration//GEN-END:variables
}
