package com.ml.vision.ftp.camera;


import com.ml.vision.ftp.listener.CameraListener;
import com.ml.vision.ftp.listener.CameraManagerBasicListener;
import java.awt.image.BufferedImage;
import org.bytedeco.javacv.OpenCVFrameConverter;
import org.bytedeco.javacv.Java2DFrameConverter;



public class CameraManagerBasic {
    
    private CameraManagerBasicListener listener;
    private OpenCVFrameConverter.ToIplImage converter;
    private java.util.List<CameraBasic> cameras;
    
    public CameraManagerBasic( java.util.List<CameraBasic> cameras ){
        this.cameras = cameras;
        converter = new OpenCVFrameConverter.ToIplImage();
    }
    
    public void start(){
        cameraListenAll();
    }
    
    private void cameraListenAll(){
        for( int i = 0; i < cameras.size(); i++ ){
            cameraListen( i );
        }
    }
    
    public void cameraListen( int camindex ){
        try{
            cameras.get( camindex ).setListener(new CameraListener() {
                
                @Override
                public void onFailed(CameraBasic camera ) {
                    listener.onFailed( camera, camera.getArrayIndex());
                }
                
                @Override
                public void onCapture(CameraBasic camera) {
                    if( camera.getLastCapture() == null ) {
                        listener.onFailed( camera, camera.getArrayIndex());
                        return;
                    }
                    listener.onCapture( camera, camera.getLastCapture(), camera.getArrayIndex() );
                    BufferedImage bimg = new Java2DFrameConverter( ).convert( converter.convert(camera.getLastCapture()) );
                    listener.onCapture( camera, bimg, camera.getArrayIndex() );
                }

                @Override
                public void onCaptureByFPS(CameraBasic camera) { }
                
            });
            cameras.get( camindex ).start();
        }catch( Exception ex){
            ex.printStackTrace();
        }
    }
    
    public void restart(java.util.List<CameraBasic> cameras){
        stop();
        System.gc();
        this.cameras = cameras;
        start();
    }
    public void stop(){
        for( int i = 0; i < cameras.size(); i++ ){
            stop(i);
        }
    }
    public void stop( int index ){
        cameras.get( index ).close();
    }
        
    public void setListener( CameraManagerBasicListener listener) {
        this.listener = listener;
    }
}
